
      subroutine Update_Chem (tdt, chem_cycle,londeg, latdeg, kel, 
     &const, humidity, emiss, mcor, qjimp, qkimp, moistq, cmf, press3c,
     &grid_height, ispb, mass, dms_oh, dms_no3, so2_oh, so2_h2o2,so2_o3, 
     &so2_hete,clwc2,ran_cloud,ncol,lchnk, sadimp, ai, bi, pctm2,
     & lwi_flags, surf_alb_uv, tau_cloud, qkimp_cld,
     & aero2d_opt, aero2d_ssa, co2_tmp ) 
      
      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2,num_emiss, emiss_timpyr,num_qjs,num_qks,
     &num_species, num_sad, lbssad_timpyr, num_qhs, num_qaqs, num_qaqqs
      
      use h_imp_phys_constants
      
      use h_imp_control, only: imgas_num,initrogen_num,ioxygen_num,
     & chem_opt,rxnr_adjust_map, nymd, nhms,  num_time_steps,  ih2o_num,
     & do_wetchem, phot_opt,isynoz_num,io3_num,iisoprene_num,ino_num
 
       use h_simpchem_cmq, only: thvintv, nhvintv,iH2O2_hv
 
      use h_imp_gen_io, only: metdata_name_org,
     & metdata_name_model, pr_qj_o3_o1d, pr_surf_emiss, pr_qj_opt_depth     

      use abortutils,    only: endrun
 
      use cam_logfile,   only: iulog              
      use cam_history,     only: outfld
!      use h_setkin_par
   
      implicit none
      
      

!     ---------
!     input argument
!     -------------
      real*8  :: chem_cycle ! number of time steps to cycle chemistry calls on, it appears imp_control.h
      real*8  :: tdt ! number of time steps to cycle chemistry calls on, it appears imp_control.h  
      

!     ----------------------
!     Argument to be passed to  Update_Sulfchem
!     ----------------------
 
      real*8,  save :: chemintv = -1.0d0
      real*8,  save :: rateintv = -1.0d0 !Guangxing Lin
      real*8  :: londeg  (ju1_gl:j2_gl)                 !passed to Do_Sulf_Solver directly
      real*8  :: latdeg  (ju1_gl:j2_gl)                !passed to Do_Sulf_Solver directly
      real*8  :: kel     (ilo:ihi, julo:jhi, k1:k2)    !used to cal RH, also passed to Do_Sulf_Solver directly
      real*8  :: const   (i1:i2, ju1:j2, k1:k2, num_species) ! changed unit from kg/kg to #/cm3 for gas, pass to solver, change unit back to kg/kg
      real*8  :: humidity(i1:i2, ju1:j2, k1:k2)        !used to cal RH, also passed
      real*8  :: emiss   (i1:i2, ju1:j2, k1:k2, num_emiss)!used to cal sulf_emiss, fSO2,nSO2,nDMS,
      real*8  :: mcor    (i1:i2, ju1:j2)                 ! used to cal sulf_emiss, not passed
      real*8  :: qjimp   (i1:i2, ju1:j2, k1:k2, num_qjs) ! num_qjs=NUM_J=1 (setkin_par.h) it is not input argument but ouput. In chem_update.F/Update_Sulfchem/Do_sulf_init,  qjh2o2_2d2x5_R8.nc is read into  qjh2o2_2d, late in sulfchem_solver.F, it is interpolated and  set qjimp 
      real*8  :: qkimp   (i1:i2, ju1:j2, k1:k2, num_qks) ! num_qks=NUM_K=8 (setkin_par.h), ouput
      real*8  :: moistq  (i1:i2, ju1:j2, k1:k2)          !! NOT used even in original case
      real*8  :: cmf    (i1:i2,  ju1:j2, k1:k2)         !! cmf is used to calculate cumulus cloud fraction, not used anymore
      real*8  :: press3c (ilo:ihi, julo:jhi, k1:k2)      !used for RH, also passed.
      real*8  :: grid_height(i1:i2, ju1:j2, k1:k2)       !used to cal sulf_emiss, not passed.
      integer :: ispb    (i1:i2, ju1:j2, k1:k2)       !the flag for boundary layer: 1, yes; 0: no 
      real*8  :: mass    (i1:i2, ju1:j2, k1:k2)          !passed to Do_Sulf_Solver directly
      real*8  :: dms_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: dms_no3 (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_h2o2(i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_o3  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_hete(i1:i2, ju1:j2, k1:k2)
      real*8  :: clwc2   (i1:i2, ju1:j2, k1:k2) !added by Cheng Zhou
      real*8  :: ran_cloud  (i1:i2, ju1:j2, k1:k2) ! added by Cheng Zhou
!      real*8  :: var_3d_tmp  (i1:i2, ju1:j2, k1:k2) ! added by Guangxing for debug  
      
      integer :: ncol,lchnk   
       
!           by Guangxing Lin
      real*8  :: sadimp(i1:i2,   ju1:j2,   k1:k2, num_sad)

      real*8  :: ai         (k1-1:k2) ! passed from outside
      real*8  :: bi         (k1-1:k2) ! passed from outside
      real*8  :: pctm2      (ilo:ihi, julo:jhi) ! passed from outside
      integer  :: lwi_flags(i1_gl:i2_gl, ju1_gl:j2_gl) ! passed from
c      outside
      real*8  :: surf_alb_uv(i1:i2, ju1:j2) ! input, passed from outside
      real*8  :: tau_cloud  (i1:i2, ju1:j2, k1:k2) ! input
      real*8  :: aero2d_opt  (i1:i2, ju1:j2) ! input Guangxing Lin 
      real*8  :: aero2d_ssa  (i1:i2, ju1:j2) ! input Guangxing Lin 
!       real*8  :: emiss_isop (i1:i2, ju1:j2) ! input
!      real*8  :: emiss_monot(i1:i2, ju1:j2) ! input
!      real*8  :: emiss_nox  (i1:i2, ju1:j2) ! input
      real*8  :: qkimp_cld  (i1:i2, ju1:j2, k1:k2, num_qks) !Guangxing
      real*8  :: co2_tmp
 
!     ----------------------
!     local Variable declarations.
!     ----------------------
      logical, save :: first = .true.
      integer :: ix,ik,il,ij,ic

      integer :: nsec_jan1 !Guangxing 
      real*8  :: rsec_jan1 !Guangxing
!=============Guangxing Lin======================
      logical, allocatable :: do_trop_chem(:, :, :)
      real*8, allocatable :: qhimp(:,:,:,:)
      real*8, allocatable :: qhimp_temp(:,:,:,:)
      real*8, allocatable :: qaqimp(:,:,:,:)
      real*8, allocatable :: qaqqimp(:,:,:,:)
      real*8, allocatable :: watv_imp(:,:,:)
      real*8, allocatable :: clwc_imp(:,:,:)
      real*8, allocatable :: clfrac_imp(:,:,:)

       real*8, allocatable  :: surf_emiss(:,:,:)
       real*8, allocatable  :: aer_water(:,:,:) ! calculated in
       integer :: ierror(100),ierr_count


!       imgas_num=253 !JIALEI **

c!     ----------------
c!     Begin execution.
c!     ----------------
         ierr_count = 0
c      tdt = 3600.0d0
         ierr_count = ierr_count+1

       Allocate (watv_imp(i1:i2,   ju1:j2,   k1:k2),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (clwc_imp(i1:i2,   ju1:j2,   k1:k2),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (clfrac_imp(i1:i2,   ju1:j2, k1:k2),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1

      Allocate (qhimp(i1:i2,   ju1:j2,   k1:k2, num_qhs),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (qhimp_temp(i1:i2,   ju1:j2,   k1:k2, num_qhs),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (qaqimp(i1:i2,   ju1:j2,   k1:k2, num_qaqs),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (qaqqimp(i1:i2,   ju1:j2,   k1:k2, num_qaqqs),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (surf_emiss(i1:i2, ju1:j2, num_species),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (aer_water(i1:i2, ju1:j2, k1:k2),
     & stat=ierror(ierr_count))
         ierr_count = ierr_count+1
      Allocate (do_trop_chem(i1:i2, ju1:j2, k1:k2),
     & stat=ierror(ierr_count))
!         ierr_count = ierr_count+1  zjl  not sure why add one here

       if ( any( ierror(1:ierr_count) .ne. 0 ) ) then
           print*, ierror(1:ierr_count)
           call endrun("Error in allocation in Chem_Update")

         end if


      do_trop_chem(:,:,:) = .true.

      qhimp = 0.0d0
      qhimp_temp = 0.0d0
      qaqimp = 0.0d0
      qaqqimp = 0.0d0
      watv_imp = 0.0d0
      clwc_imp = 0.0d0
      clfrac_imp = 0.0d0
      aer_water =0.0d0
      surf_emiss =0.0d0

      surf_emiss(:,:,iisoprene_num)=emiss(:,:,k1,4) !for isoprene 
      surf_emiss(:,:,ino_num)=emiss(:,:,k1,7) !for NO 
 
!       tdt=1800.d0 !Guangxing
!      chem_cycle=1.0d0 !Guangxing
!=============Guangxing Lin======================

 
c      tdt = 3600.0d0
     
c!     ==========
      if (first) then
c!     ==========
 
        first = .false.
        
        chem_cycle  = 1.0d0
        
        chemintv = tdt * chem_cycle
        
        rateintv = chemintv !Guangxing

!        chem_opt = 9.0d0
!   =======   Guangxing Lin ======
c       =================
        call Do_Quad_Init
c       =================
!      write(iulog,*) "JIALEI-chem-1",const(1,1,1,IORGM1)
        thvintv = rateintv
        nhvintv = Nint(chemintv/thvintv)
!   =======   Guangxing Lin ======

      end if
        const(:,:,:,isynoz_num)=const(:,:,:,io3_num) !may need to update
!later 
c   =======   Guangxing Lin ======
       call Get_Sec_Jan1
     &  (nsec_jan1, nymd, nhms)

!      write(iulog,*) "JIALEI-nsec_jan1=",nsec_jan1
      rsec_jan1 = DBLE(nsec_jan1) !Guangxing Lin
!      write(iulog,*) "JIALEI-chem-2",const(1,1,1,IORGM1)
       

c       ================
        call Update_Sad3
c       ================
     &    (press3c, kel, const,  sadimp)
!      write(iulog,*) "JIALEI-chem-3",const(1,1,1,IORGM1)

!   =======   Guangxing Lin ======
c         --------------------------------------------------------
c         Calculate the air density at the center of each grid box
c         (molecules/cm^3).
c         --------------------------------------------------------

c          const(:,:,:,imgas_num) =
c     &      press3c(i1:i2,ju1:j2,:) * MB2CGS /
c     &      (kel (i1:i2,ju1:j2,:) * BOLTZMN_E)


!   =======   Guangxing Lin ======
!          if (ioxygen_num /= 0) then
!            const(:,:,:,ioxygen_num) =
!     &        const(:,:,:,imgas_num) * MXRO2
!          end if

!          if (initrogen_num /= 0) then
!            const(:,:,:,initrogen_num) =
!     &        const(:,:,:,imgas_num) * MXRN2
!          end if
          

c--------Guangxing Lin---11072012-------------
c use the in-cloud water content and cloud fraction from CAM5 
c convert the unit from g/g to g/cm3
           clwc_imp(i1:i2,ju1:j2,k1:k2) = clwc2(i1:i2,ju1:j2,k1:k2) *
     &              (const(i1:i2,ju1:j2,k1:k2,imgas_num) * MWTAIR / AVOGAD)
           clfrac_imp(i1:i2,ju1:j2,k1:k2) = ran_cloud(i1:i2,ju1:j2,k1:k2)
!          write(iulog,*) 'gxlin-clwc= ', clwc_imp 
!          write(iulog,*) 'gxlin-clfrac = ', clfrac_imp 

c--------Guangxing Lin---11072012-------------

c          write(iulog,*) '----Start to call Update_Qk----' 
c       ==============
        call Update_Qk
c       ==============
     &    (do_wetchem, metdata_name_org, metdata_name_model,
     &     num_time_steps, ih2o_num, imgas_num, nymd, 
     &     latdeg, press3c,  kel, cmf, sadimp, qkimp,
     &      qhimp,qhimp_temp, qaqimp,qaqqimp,
     &      watv_imp, clwc_imp,clfrac_imp,
c---------Guangxing Lin 111609--------------------
     &     moistq, 
c-----------Guangxing Lin 111609----------------
     &     const,  chem_opt)
!      write(iulog,*) "JIALEI-chem-4",const(1,1,1,IORGM1)


c delele rxnr_adjust_map and rxnr_adjust,clwc, because they are not used in
c the code 
c          write(iulog,*) '----Start to call Do_Strat_Set----',imgas_num 
c         =================
          call Do_Strat_Set
c         =================
     &   (const, do_trop_chem, londeg, latdeg)
!      write(iulog,*) "JIALEI-chem-5",const(1,1,1,IORGM1)


c          write(iulog,*) '----Start to call Update_Qj----',imgas_num 

c Call TUV lookup solver for j-values (rbchem/quadchem)
c         ==============
          call Update_Qj
c         ==============
     &    ( metdata_name_org, pr_qj_o3_o1d,
     &     pr_qj_opt_depth, rateintv, rsec_jan1,  press3c, kel,
     &     const, latdeg, mcor, qjimp,
     &     ai, bi, pctm2,
     &     humidity, mass,
     &     cmf, grid_height, lwi_flags, do_trop_chem,
     &     londeg, surf_alb_uv, tau_cloud,aero2d_opt,aero2d_ssa)
!      write(iulog,*) "JIALEI-chem-6",const(1,1,1,IORGM1)

c 
c    delete imp_data_dir, max_cloud, ran_cloud, one redudant mass 
c          write(iulog,*) '----Start to call Rate_Quad----',imgas_num 

c         ====================
          call Rate_Quad
c         ====================
     &      (imgas_num, const, qjimp, qkimp,
     &      watv_imp,
     &       phot_opt, do_trop_chem)
!-----test----successful --Guangxing Lin
!            do ik=k1, k2
!            do il=i1, i2
!              do ij=ju1, j2
!                 do ic=1, num_species
!                 if(const(il,ij,ik,70).lt.1.0d-30) then
!                 write(iulog,*) 'gxlin-test-1,il,ij,ik,const',
!     $           il,ij,ik,const(il,ij,ik,70)
!                 write(43,*) 'gxlin-test-1,il,ij,ik,const',
!     $           il,ij,ik,const(il,ij,ik,70)
!          write(iulog,*) 'gxlin-clwc-1', clwc2(il,ij,ik),
!     &     ran_cloud(il,ij,ik)

!                 endif
!               enddo
!               enddo
!              enddo
!            enddo

c          write(iulog,*) '----Start to call Update_Quadchem----',imgas_num 
!      write(iulog,*) "JIALEI-chem-7",const(1,1,1,IORGM1)

c         ====================
          call Update_Quadchem
c         ====================
     &  (chemintv, const,qkimp_cld,
     &   qjimp, qkimp,qhimp,qhimp_temp, qaqimp, qaqqimp,
     &   kel, watv_imp, clwc_imp, surf_emiss,
     &   do_trop_chem,
c---------Guangxing Lin -09212011-for cloud and aqueous aerosol reaction
     &   clfrac_imp, press3c, aer_water,londeg, latdeg, co2_tmp)
c---------Guangxing Lin -09212011-for cloud and aqueous aerosol reaction
!      write(iulog,*) "JIALEI-chem-8",const(1,1,1,IORGM1)

 
c !!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module
c        print*," londeg    ", londeg   ( :  )
c        print*," latdeg    ", latdeg   ( :  )
c        print*," kel   ", kel  ( :,:,:  )
c        print*," const   ", const  ( :,:,:,:  )
c        print*," humidity    ", humidity   ( :,:,:  )
c        print*," emiss   ", emiss  ( :,:,:,:,1)
c        print*," mcor    ", mcor   ( :,: )
c        print*," qjimp   ", qjimp  ( :,:,:,:  )
c        print*," qkimp   ", qkimp  ( :,:,:,:  )
c        print*," moistq    ", moistq   ( :,:,:  )
c        print*," cmf   ", cmf  ( :,:,:  )
c        print*," press3c   ", press3c  ( :,:,:  )
c        print*," grid_height   ", grid_height  ( :,:,:  )
c        print*," mass    ", mass   ( :,:,:  )
c        print*," dms_oh    ", dms_oh   ( :,:,:  )
c        print*," dms_no3   ", dms_no3  ( :,:,:  )
c        print*," so2_oh    ", so2_oh   ( :,:,:  )
c        print*," so2_h2o2    ", so2_h2o2   ( :,:,:  )
c        print*," so2_o3  ", so2_o3 ( :,:,:  )
c        print*," so2_hete  ", so2_hete ( :,:,:  )
c        print*," clwc2   ", clwc2  ( :,:,:  )
c        print*," ran_cloud   ", ran_cloud  ( :,:,:  )

c!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module, end here   
        
!        call outfld("um_VAR3D_02",const(:,:ncol,k2:k1:-1,1),ncol,lchnk)
!        call outfld("um_VAR3D_02",aer_water(:,:ncol,k2:k1:-1),ncol,lchnk)
!        call outfld("um_VAR2D_01",londeg(:ncol),ncol,lchnk)
!        call outfld("um_VAR2D_02",latdeg(:ncol),ncol,lchnk)
!      where (const < 1.0d-30)
           
!          write(iulog,*) 'gxlin-clwc', clwc2
!            const = 1.0d-30
!      end where

!            do ik=k1, k2
!            do il=i1, i2
!              do ij=ju1, j2
!                 do ic=1, num_species
!                 if(const(il,ij,ik,70).lt.1.0d-30) then
!                 write(iulog,*) 'gxlin-test-2,il,ij,ik,const',
!     $           il,ij,ik,const(il,ij,ik,70)
!                 write(43,*) 'gxlin-test-2,il,ij,ik,const',
!     $           il,ij,ik,const(il,ij,ik,70)
!          write(iulog,*) 'gxlin-clwc-2', clwc2(il,ij,ik),
!     &     ran_cloud(il,ij,ik)

!                 endif
!               enddo
!               enddo
!              enddo
!            enddo

        
c          write(iulog,*) '----Start to call Update_Sulfchem----',imgas_num 
        Call Update_Sulfchem
     &  (chemintv, londeg, latdeg, kel, const, humidity, emiss, mcor,
     & qjimp,  moistq, cmf, press3c, grid_height,ispb, mass,
     & dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3, so2_hete,
     & clwc2,ran_cloud,ncol,lchnk,iH2O2_hv,pctm2) !JIALEI add pctm2
!      where (const < 1.0d-30)
!            const = 1.0d-30
!      end where

!    Guangxing Lin added iH2O2_hv
!          write(iulog,*) "JIALEI-chem-9",const(1,1,1,IORGM1)

     
     
c !!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module
c        print*,"-----------------------------------------------"
c        print*," londeg    ", londeg   ( :  )
c        print*," latdeg    ", latdeg   ( :  )
c        print*," kel   ", kel  ( :,:,:  )
c        print*," const   ", const  ( :,:,:,:  )
c        print*," humidity    ", humidity   ( :,:,:  )
c        print*," emiss   ", emiss  ( :,:,:,:,1)
c        print*," mcor    ", mcor   ( :,: )
c        print*," qjimp   ", qjimp  ( :,:,:,:  )
c        print*," qkimp   ", qkimp  ( :,:,:,:  )
c        print*," moistq    ", moistq   ( :,:,:  )
c        print*," cmf   ", cmf  ( :,:,:  )
c        print*," press3c   ", press3c  ( :,:,:  )
c        print*," grid_height   ", grid_height  ( :,:,:  )
c        print*," mass    ", mass   ( :,:,:  )
c        print*," dms_oh    ", dms_oh   ( :,:,:  )
c        print*," dms_no3   ", dms_no3  ( :,:,:  )
c        print*," so2_oh    ", so2_oh   ( :,:,:  )
c        print*," so2_h2o2    ", so2_h2o2   ( :,:,:  )
c        print*," so2_o3  ", so2_o3 ( :,:,:  )
c        print*," so2_hete  ", so2_hete ( :,:,:  )
c        print*," clwc2   ", clwc2  ( :,:,:  )
c        print*," ran_cloud   ", ran_cloud  ( :,:,:  )

c!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module, end here      

c          write(iulog,*) '----Start to call Distri_SOA_Par----------',imgas_num

c------------JIALEI--12/23/2016---Distribute SOA on each type of aerosol--------
       Call Distri_SOA_Par
     & (press3c,kel, const,qkimp,qkimp_cld,so2_hete,so2_o3)
!           write(iulog,*) 'JIALEI Finish Distribution',imgas_num
!      write(iulog,*) "JIALEI-chem-10",const(1,1,1,IORGM1)

c--------------------------------------------------------------------------------


      Deallocate (qhimp)
      Deallocate (qhimp_temp)
      Deallocate (qaqimp)
      Deallocate (qaqqimp)
      Deallocate (watv_imp)
      Deallocate (clwc_imp)
      Deallocate (clfrac_imp)
      Deallocate (surf_emiss)
      Deallocate (aer_water)
      Deallocate (do_trop_chem)

c      write(iulog,*) 'JIALEI Finish Distribution1',imgas_num

2010         end
 
 
 
c-----------------------------------------------------------------------------
c
c ROUTINE
c   Update_Sulfchem
c
c DESCRIPTION
c   This routine updates the sulfur chemistry.
c
c ARGUMENTS
c   chemintv    : chemistry time step (s)
c   londeg      : longitude (deg)
c   latdeg      : latitude  (deg)
c   kel         : temperature (degK)
c   const       : species concentration, known at zone centers (mixing ratio)
c   humidity    : specific humidity  (g/kg)
c   emiss       : array of emissions (kg/s)
c   mcor        : area of grid box   (m^2)
c   qjimp       : photolysis rate constants (s^-1)
c   qkimp       : thermal    rate constants (units vary)
c   moistq      : moisture changes due to wet processes (g/kg/day)
c   cmf1        : convective mass flux used for cloud fraction calculation
c                 (kg/m^2/s)
c   press3c     : atmospheric pressure at the center of each grid box (mb)
c   grid_height : height of each grid box (m)
c   mass        : total mass of the atmosphere within each grid box (kg)
c   dms_oh      : SO2 production from DMS + OH  accumulated since last output
c                 used for sulfur budget (kg)
c   dms_no3     : SO2 production from DMS + NO3 accumulated since last output
c                 used for sulfur budget (kg)
c   so2_oh      : SO4 production from SO2 + OH  accumulated since last output
c                 used for sulfur budget (kg)
c   so2_h2o2    : SO4 production from SO2 + H2O2 (aqueous phase) accumulated
c                 since last output used for sulfur budget (kg)
c   so2_o3      : SO4 production from SO2 + O3   (aqueous phase) accumulated
c                 since last output used for sulfur budget (kg)
c   so2_hete    : SO4 production from SO2 heter. reactions on dust/sea salt
c                 accumulated since last output used for sulfur budget (kg)
c   clwc2       : in cloud liquid water content from CAM5 (g/g) !added by Cheng Zhou
c   ran_cloud       : total cloud fraction from CAM5  !added by Cheng Zhou
c-----------------------------------------------------------------------------

c change note by Cheng Zhou
c  1) include imp_dims.h is replaced by use h_imp_dims
c  2) include imp_control.h is replaced by use h_imp_control
c  3) include imp_gen_io.h is replaced by use h_imp_gen_io
c  4) imon is always set to 1, we will use udpated emission from CAM5 at each step
c  5) do not call Do_Sulf_Init, qjimp will be dealt late, now just use input value.

      subroutine Update_Sulfchem
     &  (chemintv, londeg, latdeg, kel, const, humidity, emiss, mcor,
     & qjimp,  moistq, cmf1, press3c, grid_height,ispb, mass,
     & dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3, so2_hete,
     & clwc2,ran_cloud,ncol,lchnk, iH2O2_hv,pctm2) !JIALEI add pctm2

!   Guangxing Lin added iH2O2_hv, remove qkimp
      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2,
     &num_emiss, emiss_timpyr,num_qjs,num_qks,num_species,num_molefrac,
     &loc_proc, pr_diag,num_chem
     
      use h_imp_control, only: imgas_num,do_clear_sky,nymd,nhms,
     &mw,emiss_map, num_time_steps
      
      use h_imp_gen_io, only: pr_sulf_src,aqua_infile_name
      
      use h_imp_time_constants
      use h_imp_phys_constants
      use h_setkin_par
      use h_setkin_depos
     
      use cam_logfile,   only: iulog 
      implicit none

c#     include "imp_time_constants.h"
c#     include "imp_phys_constants.h"
c#     include "imp_dims.h"
c#     include "imp_control.h"
c#     include "imp_gen_io.h"
c#     include "setkin_par.h"
c#     include "setkin_depos.h"


c     ----------------------
c     Argument declarations.
c     ----------------------

      real*8  :: chemintv
      real*8  :: londeg  (ju1_gl:j2_gl)                 !passed to Do_Sulf_Solver directly
      real*8  :: latdeg  (ju1_gl:j2_gl)                !passed to Do_Sulf_Solver directly
      real*8  :: kel     (ilo:ihi, julo:jhi, k1:k2)    !used to cal RH, also passed to Do_Sulf_Solver directly
      real*8  :: const   (i1:i2, ju1:j2, k1:k2, num_species) ! changed unit from kg/kg to #/cm3 for gas, pass to solver, change unit back to kg/kg
      real*8  :: humidity(i1:i2, ju1:j2, k1:k2)        !used to cal RH, also passed
      real*8  :: emiss   (i1:i2, ju1:j2, k1:k2, num_emiss)!used to cal sulf_emiss, not passed
      real*8  :: mcor    (i1:i2, ju1:j2)                 ! used to cal sulf_emiss, not passed
      real*8  :: qjimp   (i1:i2, ju1:j2, k1:k2, num_qjs) ! num_qjs=NUM_J=1 (setkin_par.h) it is not input argument but ouput. In chem_update.F/Update_Sulfchem/Do_sulf_init,  qjh2o2_2d2x5_R8.nc is read into  qjh2o2_2d, late in sulfchem_solver.F, it is interpolated and  set qjimp 
!      real*8  :: qkimp   (i1:i2, ju1:j2, k1:k2, num_qks) ! num_qks=NUM_K=8 (setkin_par.h), ouput
      real*8  :: moistq  (i1:i2, ju1:j2, k1:k2)          !! NOT used even in original case
      real*8  :: cmf1    (i1:i2,  ju1:j2, k1:k2)         !! cmf is used to calculate cumulus cloud fraction, not used anymore
      real*8  :: press3c (ilo:ihi, julo:jhi, k1:k2)      !used for RH, also passed.
      real*8  :: grid_height(i1:i2, ju1:j2, k1:k2)       !used to cal sulf_emiss, not passed.
      integer :: ispb    (i1:i2, ju1:j2, k1:k2)       !the flag for boundary layer: 1, yes; 0: no 
      real*8  :: mass    (i1:i2, ju1:j2, k1:k2)          !passed to Do_Sulf_Solver directly
      real*8  :: dms_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: dms_no3 (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_h2o2(i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_o3  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_hete(i1:i2, ju1:j2, k1:k2)
      real*8  :: clwc2   (i1:i2, ju1:j2, k1:k2) !added by Cheng Zhou
      real*8  :: ran_cloud  (i1:i2, ju1:j2, k1:k2) ! added by Cheng Zhou
      integer :: ncol,lchnk  
      integer :: iH2O2_hv !Guangxing Lin

      real*8  :: pctm2      (ilo:ihi, julo:jhi) !JIALEI
 
c     -----------------------
c     Parameter declarations.
c     -----------------------

      real*8, parameter :: CMPM3 = CMPM * CMPM * CMPM


c     ----------------------
c     Variable declarations.
c     ----------------------

      logical, save :: first = .true.

      integer :: il, ij, ik
      integer :: ic, icx
      integer :: idumday, idumyear
      integer :: imon
      integer :: month

      real*8  :: fac

!      real*8  :: conv_emiss(i1:i2, ju1:j2, k1:k2)  !Guangxing Lin
!      real*8  :: sulf_emiss(i1:i2, ju1:j2, k1:k2, num_species)



c     -----------------------------------------------------
c     clfrac : total cloud fraction [0 - 1]
c     lwccol : in-cloud liquid water in each grid box (g/g)
c     relhum : relative humidity [0 - 1]
c     -----------------------------------------------------

      real*8, allocatable :: clfrac (:,:,:)
      real*8, allocatable :: lwccol (:,:,:)
      real*8, allocatable :: relhum (:,:,:)
      real*8, allocatable :: sulf_emiss(:, :, :, :)!Guangxing Lin
      real*8, allocatable :: const_nb(:, :, :, :)!Guangxing Lin
     

c     ----------------
c     Begin execution.
c     ----------------
 
!      if (pr_diag) then
!        Write (6,*) 'Update_Sulfchem called by ', loc_proc
!      end if
!        Write (iulog,*) 'Update_Sulfchem called by ', loc_proc


      Allocate (clfrac (i1:i2, ju1:j2, k1:k2))
      clfrac = 0.0d0

      Allocate (lwccol (i1:i2, ju1:j2, k1:k2))
      Allocate (relhum (i1:i2, ju1:j2, k1:k2))
      lwccol = 0.0d0; relhum = 0.0d0
      Allocate (sulf_emiss (i1:i2, ju1:j2, k1:k2, 1:num_species))
      Allocate (const_nb (i1:i2, ju1:j2, k1:k2, 1:num_species))

      const_nb=0.0d0

      if (first) then

        first = .false.

        if (pr_sulf_src) then
          dms_oh  (:,:,:) = 0.0d0
          dms_no3 (:,:,:) = 0.0d0

          so2_oh  (:,:,:) = 0.0d0
          so2_h2o2(:,:,:) = 0.0d0
          so2_o3  (:,:,:) = 0.0d0
          so2_hete(:,:,:) = 0.0d0
        end if

cc       =================
c        call Do_Sulf_Init
cc       =================
c     &    (pr_diag, loc_proc, j2_gl, qj_infile_name, qj_var_name)./c

      end if
       

c     -----------------------------------------------------------
c     Calculate relative humidity from Seinfeld (1986) p. 181.
c     The first rh is the temperature dependent parameter a.
c     The second rh is the saturation vapor pressure of water.
c     The third rh is the actual relative humidity as a fraction.
c     Then make sure rh is between 0 and 0.95.
c     -----------------------------------------------------------

      do ij = ju1, j2
        do il = i1, i2

          relhum(il,ij,:) =
     &      1.0d0 - (373.15d0 / kel(il,ij,:))

          relhum(il,ij,:) =
     &      1013.25d0 * Exp (13.3185d0 * relhum(il,ij,:)    -
     &                        1.9760d0 * relhum(il,ij,:)**2 -
     &                        0.6445d0 * relhum(il,ij,:)**3 -
     &                        0.1299d0 * relhum(il,ij,:)**4)

          relhum(il,ij,:) =
     &      humidity(il,ij,:) * MWTAIR / 18.0d0 / GPKG *
     &      press3c(il,ij,:) / relhum(il,ij,:)

          relhum(il,ij,:) =
     &      Max (Min (relhum(il,ij,:), 0.95d0), 0.0d0)

        end do
      end do

   
c     ======================
      if (do_clear_sky) then
c     ======================

        clfrac(:,:,:) = 0.0d0
        lwccol(:,:,:) = 0.0d0

c     ====
      else
c     ====

c     write(*,*) maxval(lwccol),maxval(clwc2)
      lwccol(:,:,:) = clwc2(:,:,:) !added by Cheng Zhou, use in cloud liquid water content from CAM5 
      clfrac(:,:,:) = ran_cloud(:,:,:) !added by Cheng Zhou, total cloud fraction from CAM5 
      
c     ======
      end if
c     ======

     
c     ------------------------------------------------
c     Change units from mixing ratio to concentration. (#/cm^3)
c     (only for gas-species, not for aerosols).
c     ------------------------------------------------

      do ic = 1, num_molefrac

        if (aerosol(ic) <= 0) then
          const(i1:i2,ju1:j2,:,ic) =
     &      const(i1:i2,ju1:j2,:,ic) *
     &      const(i1:i2,ju1:j2,:,imgas_num)!JIALEI imgas_num)
        end if

      end do


!            do ik=k1, k2
!            do il=i1, i2
!              do ij=ju1, j2
!                 do ic=1, num_species
!                 if(const(il,ij,ik,70).eq.0.0) then
!                 write(iulog,*) 'gxlin-test-3,il,ij,ik,ic,const',
!     $           il,ij,ik,const(il,ij,ik,70)
!                 write(43,*) 'gxlin-test-3,il,ij,ik,ic,const',
!     $           il,ij,ik,const(il,ij,ik,70)

!                 endif
!               enddo
!               enddo
!              enddo
!            enddo

c Enter photochemical concentrations for solver.
      do ic = 1, num_chem
         const_nb(i1:i2,ju1:j2,k1:k2,ic) = const(i1:i2,ju1:j2, k1:k2,ic)
      end do


cc set imon to 1 all the time
c      if (emiss_timpyr == MONTHS_PER_YEAR) then
c        call Split_Time_Flds (nymd, idumyear, month, idumday)
c        imon = month
c      else
!        imon = 1
c      end if


c     --------------------------------------------------------------------
c     Calculate conversion factor to go from kg/box/s to molecules/cm^3/s,
c     but leave out the molecular weight term for each species.
c     --------------------------------------------------------------------

!      fac = AVOGAD * GPKG
!
!      do ik = k1, k2
!        conv_emiss(:,:,ik) =
!     &    fac / mcor(:,:) / CMPM3 / grid_height(:,:,ik)
!      end do
!
!
!c     --------------------------------------------------------------
!c     Now do the conversion for each sulfur species that is emitted.
!c     --------------------------------------------------------------
!
!      sulf_emiss(:,:,:,:) = 0.0d0
!
!      do icx = 1, num_emiss
!
!        ic = emiss_map(icx)
!
!        if ((ic == IFSO2) .or. (ic == INSO2) .or. (ic == INDMS)) then
!          sulf_emiss(:,:,:,ic) =
!     &      emiss(:,:,:,icx,imon) * conv_emiss(:,:,:) / mw(ic)
!        end if
!
!      end do

      sulf_emiss(:,:,:,:) = 0.0d0
      do icx = 1, num_emiss

        ic = emiss_map(icx)

        if ((ic == IFSO2) .or. (ic == INSO2) .or. (ic == INDMS)) then !need to deal with aSO2 and emiss map
          sulf_emiss(:,:,:,ic) = emiss(:,:,:,icx) 
        end if

      end do     
c     ===================
      call Do_Sulf_Solver
c     ===================
     &  (chemintv, nymd, nhms, kel(i1:i2,ju1:j2,k1:k2), 
     &   press3c(i1:i2,ju1:j2,k1:k2), ispb(i1:i2, ju1:j2, k1:k2), const_nb, humidity, 
     &   sulf_emiss, qjimp, clfrac, lwccol, relhum, 
     &   aqua_infile_name, num_time_steps, londeg, latdeg, mass,
     &   pr_sulf_src, dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3,
     &   grid_height,ncol,lchnk, iH2O2_hv,pctm2) !JIALEI add pctm2
c Guangxing Lin added iH2O2_hv, delete qkimp

!      write(iulog,*) "JIALEI-after solve",const_nb(1,1,1,IORGM1)
      do ic = num_chem , 1, -1
c ** End of modifications by Luis Olcese, UM
c ********************************************
      if(ic.ne.imgas_num) then
        do ik = k2, k1, -1
          do ij = j2, ju1, -1
            do il = i2, i1, -1
              const(il,ij,ik,ic) = const_nb(il,ij,ik,ic)
            end do
          end do
        end do
        endif                   !if(ic.ne.imgas_num) then
      end do

c     ----------------------------------------------------
c     Change units from concentration (#/cm^3) back to volume mixing ratio (#/#)
c     (only for gas-species).
c     ----------------------------------------------------

      do ic = 1, num_molefrac
        if (aerosol(ic) <= 0) then
          const(i1:i2,ju1:j2,:,ic) =
     &      const(i1:i2,ju1:j2,:,ic) /
     &      const(i1:i2,ju1:j2,:,imgas_num)
        end if
      end do

      Deallocate (clfrac)
      Deallocate (lwccol)
      Deallocate (relhum)
      Deallocate (sulf_emiss)
      Deallocate (const_nb)

      return

      end


c-----------------------------------------------------------------------------
c
c ROUTINE
c   Rate_Quad
c
c DESCRIPTION
c   This routine combines the rate constants of the photolysis and
c   thermal processes.
c
c   It calls the subroutine rbhvrates to obtain  hv rates from j-values.
c   These are added into the combined rate array (ratek)
c
c ARGUMENTS
c   imgas_num      : const array index for air density
c   const          : species concentration, known at zone centers
c                    (mixing ratio)
c   qjimp          : photolysis rate constants (s^-1)
c   qkimp          : thermal    rate constants (units vary)
c   phot_opt       : phot option
c   do_trop_chem   : do tropospheric chemistry
c
c Added by Sandy Sillman, 2007:  water vapor and cloud liquid water.
c watv
c  watv_imp    :  water vapor, molec/cm3 (from Qk_update)
c
c-----------------------------------------------------------------------------

       subroutine Rate_Quad
     &  (imgas_num, const, qjimp, qkimp,
     &   watv_imp,
     &   phot_opt, do_trop_chem)

       use h_imp_dims
       use h_rbchemmech
       implicit none

c#     include "imp_dims.h"
c Added by Sandy Sillman, 2007 (to pass chem. mechanism to rate calc.)
c#     include "rbchemmech.h"


c     ----------------------
c     Argument declarations.
c     ----------------------

      logical :: do_trop_chem(i1:i2, ju1:j2, k1:k2)

      integer :: imgas_num
      integer :: phot_opt

      real*8  :: const (i1:i2, ju1:j2, k1:k2, num_species)
      real*8  :: qjimp (i1:i2, ju1:j2, k1:k2, num_qjs)
      real*8  :: qkimp (i1:i2, ju1:j2, k1:k2, num_qks)

c Added by Sandy Sillman, 2007:  water vapor
      real*8  :: watv_imp     (i1:i2, ju1:j2, k1:k2)


c     ----------------------
c     Variable declarations.
c     ----------------------

      integer :: ic, iq, iqj
      integer :: il, ij, ik

      real*8  :: const1 (1, num_species)
croy      real*8  :: qjimp1 (1, num_qjs) 
croy      real*8  :: qkimp1 (1, num_qks)

      real*8  :: hvrate (1, num_qjs)        ! num_qjs or 56
      real*8  :: ratek  (1, num_qks)        ! num_qks or c_rdim

c Added by Sandy Sillman (7/07):  density, water vapor (molec/cm3)
      real*8  ::  dens(1), watv(1)

c     ----------------
c     Begin execution.
c     ----------------
      if (pr_diag) then
        Write (6,*) 'Rate_Quad called by ', loc_proc
      end if

      const1 (:,:) = 0.0d0
croy      qjimp1 (:,:) = 0.0d0
croy      qkimp1 (:,:) = 0.0d0
      hvrate  = 0.0d0
      ratek   = 0.0d0

      do ik = k1, k2
        do ij = ju1, j2
          do il = i1, i2
            if (do_trop_chem(il,ij,ik)) then
c
c Constants (xr) no longer used in  rb hvrates. (Sandy Sillman 7/07)
c             do ic = 1, num_species
c               const1(1,ic) = const(il,ij,ik,ic)
c             end do
c
c Water vapor concentration (molec/cm3) for rb hvrates (Sandy 7/07)
c    Calculated in Qk_Update, imported here.

             watv = watv_imp(il, ij, ik)
             dens = const(il,ij,ik,imgas_num)
c Back to original:  assign qj, qk values.
              do iq = 1, num_qjs
croy                qjimp1(1,iq) = qjimp(il,ij,ik,iq)
                hvrate(1,iq) = qjimp(il,ij,ik,iq)
              end do
croy              do iq = 1, num_qks
              do iq = 1, c_nreac
croy                qkimp1(1,iq) = qkimp(il,ij,ik,iq)
                ratek (1,iq) = qkimp(il,ij,ik,iq)
              end do
c call rb (quad) photolysis rate assignment program
c             ====================
              call rbhvrates
c             ====================
croy     &         (qkimp1, qjimp1, dens,   watv  )
     &         (ratek , hvrate, dens,   watv  )
c    &         (ratek , hvrate, dens,   watv  ,lhvdebug  )

c ORIGINAL  call bhvrates- does not include   phot_opt.
c        subroutine bhvrates  (ratek, hvrate, xr)
c             ====================
c             call bhvrates
c             ====================
c    &         (qkimp1, qjimp1
c    &             const1, phot_opt)

croy              do iq = 1, num_qks
croy                qkimp(il,ij,ik,iq) = qkimp1(1, iq)
              do iq = 1, c_nreac
                qkimp(il,ij,ik,iq) = ratek (1, iq)
                qkimp(il,ij,ik,iq) = Max (0.0d0, qkimp(il,ij,ik,iq))
              end do
c call rb (quad) photolysis rate assignment program
c             ====================
              call rbhvrates
c             ====================
croy     &         (qkimp1, qjimp1, dens,   watv  )
     &         (ratek , hvrate, dens,   watv  )
c    &         (ratek , hvrate, dens,   watv  ,lhvdebug  )

c ORIGINAL  call bhvrates- does not include   phot_opt.
c        subroutine bhvrates  (ratek, hvrate, xr)
c             ====================
c             call bhvrates
c             ====================
c    &         (qkimp1, qjimp1
c    &             const1, phot_opt)

croy              do iq = 1, num_qks
croy                qkimp(il,ij,ik,iq) = qkimp1(1, iq)
              do iq = 1, c_nreac
                qkimp(il,ij,ik,iq) = ratek (1, iq)
                qkimp(il,ij,ik,iq) = Max (0.0d0, qkimp(il,ij,ik,iq))
              end do

c call rb (quad) photolysis rate assignment program
c             ====================
              call rbhvrates
c             ====================
croy     &         (qkimp1, qjimp1, dens,   watv  )
     &         (ratek , hvrate, dens,   watv  )
c    &         (ratek , hvrate, dens,   watv  ,lhvdebug  )

c ORIGINAL  call bhvrates- does not include   phot_opt.
c        subroutine bhvrates  (ratek, hvrate, xr)
c             ====================
c             call bhvrates
c             ====================
c    &         (qkimp1, qjimp1
c    &             const1, phot_opt)

croy              do iq = 1, num_qks
croy                qkimp(il,ij,ik,iq) = qkimp1(1, iq)
              do iq = 1, c_nreac
                qkimp(il,ij,ik,iq) = ratek (1, iq)
                qkimp(il,ij,ik,iq) = Max (0.0d0, qkimp(il,ij,ik,iq))
              end do

c ********************************************
c * Modified by Luis Olcese, UM
cc TEST CHEM WRITE:
cc      coordinate this with TEST CHEM WRITE in quadchem_solver.F
cc        and qk_update.F and tuv_lookup.F

c          if(

cc OPTION FOR NO TEST CHEM WRITE
cc    &         (il.eq.-305)

cc OPTION FOR SPECIFIC GRIDS
cc   NOTE - Coordinate this with TEST CHEM output  in qk_update.F

c     &         (il.eq.36.and.ij.eq.2                           )
c     &   .or. (il.eq.59.and. ij.eq. 6                           )
cc    &   .or. (il.eq.66.and. ij.eq. 9.and.(ik.eq.1.or.ik.eq.14) )

c     &                                           )then
c           write(6    , 201) il, ij, ik
c201        format(/'TEST CHEM in Rate_Quad:        il,ij,ik= ',/,3i3)
c           write(6    ,205) ratek(1, 1), ratek(1,   22),
c     &                      ratek(1,229),
c     &                      ratek(1, 233), ratek(1, 234)
c205       format(' RATE 1, 22,229, 233, 234=',/,(5(1pe10.3)) )
c         endif   ! END TEST CHEM WRITE

c ********************************************
            end if
          end do
        end do
      end do


      return

      end

 
c-----------------------------------------------------------------------------
c
c ROUTINE
c   Update_Quadchem
c
c DESCRIPTION
c   This routine updates the quadchem chemistry.

c 2007 addition (Sandy Sillman):
c       Calc watv.
c       import into Quadchem
c       Henry's law and aqueous rates (qhimp, qaqimp, qaqqimp)
c       LWC (clwc, gm/m3 from imp_arrays_trop.h)
c
c ARGUMENTS
c   chemintv    : chemistry time step (s)
c   const       : species concentration, known at zone centers (mixing
c   ratio)
c   hv_imp      : variables used in chemistry (units vary)
c   ratek_imp   : reaction rate constants (units vary)
c   rateh_imp   : Henry's law constants (mole lit-1 atm-1)
c   rateh_imp_temp   : Henry's law constants (units?)
c   rateq_imp   : aqueous equilibrium constants (usually mole lit-1)
c   rateqq_imp  : special equilibrium constants (usually mole lit-1)
c   watv_imp    :  water vapor, molec/cm3 (from Qk_update)
c   clwc_imp    :  cloud liquid water, g/m3 (from Qk_update)
c   do_trop_chem: do tropospheric chemistry
c
c-----------------------------------------------------------------------------

c 2007 addition (Sandy Sillman):  import into Quadchem
c       Henry's law and aqueous rates (qhimp, qaqimp, qaqqimp)
c       LWC (clwc, gm/m3 from imp_arrays_trop.h)

        subroutine Update_Quadchem
     &  (chemintv, const, ratek_cld_imp,
     &   hv_imp, ratek_imp, rateh_imp,rateh_imp_temp,
     &   rateq_imp, rateqq_imp,
     &   temp_imp, watv_imp, clwc_imp, surf_emiss,
     &           do_trop_chem,
c---------Guangxing Lin -09212011-for clouds and aqueous aerosol
c         reactions      
     &    clfrac, press3c, aer_water,londeg, latdeg,co2_tmp)
c---------Guangxing Lin -09212011-for clouds and aqueous aerosol
c         reactions      

c      use Ftiming_Dao

      use h_imp_time_constants
      use h_imp_phys_constants
      use h_imp_dims
      use h_imp_control
      use h_rbchemmech
      use h_sulfquad
      use h_setkin_par
      use h_sulfchem,      only: wtmair, wtmso4
      use cam_logfile,   only: iulog
      implicit none


c#     include "imp_time_constants.h"
c#     include "imp_phys_constants.h"
c#     include "imp_dims.h"
c#     include "imp_control.h"

c Added by Sandy Sillman, 2007 (to pass chem. mechanism to rate calc.)
c#     include "rbchemmech.h"
c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c#     include "sulfquad.h"
c ** End of modifications by Luis Olcese, UM
c ********************************************

c     ----------------------
c     Argument declarations.
c     ----------------------

      logical :: do_trop_chem(i1:i2, ju1:j2, k1:k2)

      real*8  :: chemintv
      real*8  :: const       (i1:i2, ju1:j2, k1:k2, num_species)
      real*8  :: hv_imp      (i1:i2, ju1:j2, k1:k2, num_qjs)
       real*8  :: ratek_imp   (i1:i2, ju1:j2, k1:k2, num_qks)
      real*8  :: ratek_cld_imp (i1:i2, ju1:j2, k1:k2, num_qks)
      real*8  :: rateh_imp   (i1:i2, ju1:j2, k1:k2, num_qhs)
      real*8  :: rateh_imp_temp (i1:i2, ju1:j2, k1:k2, num_qhs)
      real*8  :: rateq_imp   (i1:i2, ju1:j2, k1:k2, num_qaqs)
      real*8  :: rateqq_imp  (i1:i2, ju1:j2, k1:k2, num_qaqqs)
c     real*8  :: lbssad(i1:i2,   ju1:j2,   k1:k2, lbssad_timpyr)
      real*8  :: surf_emiss  (i1:i2, ju1:j2, num_species)
      real*8  :: temp_imp    (ilo:ihi, julo:jhi, k1:k2)  ! based on
c temp3 in qk_update
      real*8  :: watv_imp    (i1:i2, ju1:j2, k1:k2)
      real*8  :: clwc_imp    (i1:i2, ju1:j2, k1:k2)
      real*8  :: clfrac    (i1:i2, ju1:j2, k1:k2)
      real*8  :: press3c(ilo:ihi, julo:jhi, k1:k2)
      real*8  :: aer_water    (i1:i2, ju1:j2, k1:k2)
      real*8  :: londeg    (ju1_gl:j2_gl) !just pcols
      real*8  :: latdeg    (ju1_gl:j2_gl)
      real*8  :: co2_tmp  !volume mixing ratio 

c     ----------------------
c     Variable declarations.
c     ----------------------

      logical, save :: first = .true.

      integer :: il, ij, ik, ic
      integer :: iyr,imon,iday

      real*8  :: hcho = 1.0d-10 !Sandy suggests: 100ppt
      real*8  :: h2o2 = 1.0d-10 !The minimum from references: 100ppt
       real*8  :: nox  = 3.0d-11 !Sandy suggests: 30ppt
      real*8  :: no,no2
      real*8  :: xxnox,xxnoxr
c      Guangxing Lin-------
c     save DMS, SO2, SULF, since the change in their concentrations will
c     be updated in sulf_chem
      real*8 :: dms_saved (i1:i2, ju1:j2, k1:k2)
      real*8 :: so2_saved(i1:i2, ju1:j2, k1:k2)
      real*8 :: so4_saved(i1:i2, ju1:j2, k1:k2)


c      real*8, allocatable, save :: ch4(:)    !volumn mixing ratio
!      real*8, allocatable, save :: co(:,:,:) !volumn mixing ratio
!      !Guangxing
      real*8, allocatable :: const_nb(:,:,:,:)
      real*8, allocatable :: clwc_nb(:,:,:) !Guangxing Lin
c     ===============================================================
ccc!! Non-standard F90 below!?
c     Only way I could find to share memory between const & const_nb;
c     hopefully it will work on all the machines we run on.
c     Also see below.
c     ===============================================================

croy      real*8  :: const_nb

croy      pointer (ptr_const_nb,
croy     &         const_nb(i1:i2, ju1:j2, k1:k2, 1:num_species))
       Allocate (const_nb(i1:i2, ju1:j2, k1:k2, 1:num_species))
       Allocate (clwc_nb(i1:i2, ju1:j2, k1:k2 ))
!Guangxing lin
       const_nb = 0.0d0
       clwc_nb = 0.0d0 !Guangxing Lin
c     ----------------
c     Begin execution.
c     ----------------

      if (pr_diag) then
        Write (6,*) 'Update_Quadchem called by ', loc_proc
      end if

c     ===============
      if (first) then
c     ===============
        first = .false.

c     ==========
      end if
c     ==========


c     ===============================================================
ccc!! Non-standard F90 below!?
c     Only way I could find to share memory between const & const_nb;
c     hopefully it will work on all the machines we run on.
c     ===============================================================
croy      ptr_const_nb = Loc (const(ilo,julo,k1,1))

c-----Guangxing Lin-------
c      pass the SO2, DMS, SO4 predicted in sulf chemistry to gas phase
!      chemistry

       dms_saved =const(i1:i2,ju1:j2,k1:k2, INDMS)

       const(i1:i2,ju1:j2,k1:k2,IDMSS)=dms_saved

       so2_saved = const(i1:i2, ju1:j2, k1:k2, IFSO2) +
     &           const(i1:i2, ju1:j2, k1:k2, INSO2)

       const(i1:i2,ju1:j2,k1:k2, ISO2S)=so2_saved

!      wtmair/wtmso4: from mass mixing ratio (mmr) to vmr
       so4_saved = const(i1:i2,ju1:j2, k1:k2, ISO4G) +
     &   const(i1:i2,ju1:j2, k1:k2, ISO4M1)*wtmair/wtmso4 +
     &   const(i1:i2,ju1:j2, k1:k2, ISO4M2)*wtmair/wtmso4 +
     &   const(i1:i2,ju1:j2, k1:k2, ISO4M3)*wtmair/wtmso4

       do ic=ISO4NOC, ISO4S4
          so4_saved =so4_saved +
     &  const(i1:i2,ju1:j2,k1:k2,ic)*wtmair/wtmso4
       end do
          do ic=ISO4oSO, ISO4IEP
          so4_saved =so4_saved +
     &  const(i1:i2,ju1:j2,k1:k2, ic)*wtmair/wtmso4
       end do

       const(i1:i2,ju1:j2, k1:k2,ISO4S)= so4_saved
!       const(i1:i2,ju1:j2, k1:k2,ISO4S)=5.0d-9 !debug only, Guangxing 

        clwc_nb(i1:i2,ju1:j2,k1:k2) = clwc_imp(i1:i2,ju1:j2,k1:k2) 

c-----Guangxing Lin-------

c     ------------------------------------------------
c     Change units from mixing ratio to concentration.
c     ------------------------------------------------
      !const(i1:i2,ju1:j2,:,235)=0
!      if(i1.le.1.and.i2.ge.1.and.ju1.le.1.and.j2.ge.1)then
!       do ik=k2,k1,-1
!        write(iulog,*) "JIALEI",ik,const(1,1,ik,235)
!       end do
!      end if  JIALEI DEBUG for ESTER

      do ic = 1, num_molefrac

        const(i1:i2,ju1:j2,:,ic) =
     &    const(i1:i2,ju1:j2,:,ic) *
     &    const(i1:i2,ju1:j2,:,imgas_num)

      end do
      
           
c Enter photochemical concentrations for solver.
      do ic = 1, num_chem
         const_nb(i1:i2,ju1:j2,k1:k2,ic) = const(i1:i2,ju1:j2, k1:k2,ic)
      end do

c      if (do_ftiming) call Ftiming_On  ('Do_Quad_Solver')

c     ===================
      call Do_Quad_Solver
c     ===================
     &   (chemintv, const_nb, ratek_cld_imp,
     &    ratek_imp, rateh_imp, rateh_imp_temp,rateq_imp, rateqq_imp,
     &    temp_imp, watv_imp, clwc_nb,
     &    surf_emiss, do_trop_chem,
c----Guangxing Lin -09212011------------
     &    clfrac,press3c, aer_water, londeg, latdeg,co2_tmp)
c----Guangxing Lin -09212011------------

c    &  (chemintv, const_nb,
c    &   ratek_imp, rateh_imp, rateq_imp, rateqq_imp,
c    &   watv_imp, clwc_imp, surf_emiss,
c    &                    do_trop_chem)
c     cut:   lbssad, sad_opt
c       if (do_ftiming) call Ftiming_Off ('Do_Quad_Solver')

c  Error found 807:
c    This do loop  must not overwrite const(num_imgas) (=density)
c
c   Density should be passed to solver as const(il,ij,ik,imgas_num)
c   but must not be overwritten!
c
c 2007 settings:
c    c_nchem1 = 89.  89 species, but 89th is CO2.
c    IMGAS = index for DENSITY = 89.
c    NACT = number of active species = 88
c  Temporary correction:  use num_active
c    Note, CO2 should be set in Quadchem_solver.
c  num_chem = 89


c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** Changed to include the quadchem/sulfur chemistry
c       do ic = num_molefrac  , 1, -1
       do ic = num_chem , 1, -1
c ** End of modifications by Luis Olcese, UM
c ********************************************
      if(ic.ne.imgas_num) then
        do ik = k2, k1, -1
          do ij = j2, ju1, -1
            do il = i2, i1, -1
              const(il,ij,ik,ic) = const_nb(il,ij,ik,ic)
            end do
          end do
        end do
        endif                   !if(ic.ne.imgas_num) then
      end do

c     -----------------------------------------------------
c     Change units from concentration back to mixing ratio.
c     -----------------------------------------------------

      do ic = 1, num_molefrac
        const(i1:i2,ju1:j2,:,ic) =
     &    const(i1:i2,ju1:j2,:,ic) /
     &    const(i1:i2,ju1:j2,:,imgas_num)
      end do
      where(const(i1:i2,ju1:j2,:,:)<1.0E-30) const(i1:i2,ju1:j2,:,:)=1.0E-30  !JIALEI 20170712
!      if(i1.le.1.and.i2.ge.1.and.ju1.le.1.and.j2.ge.1)then
!       do ik=k2,k1,-1
!        write(iulog,*) "JIALEI-1",ik,const(1,1,ik,235)
!        end do
!        do ik=k2,k1,-1
!        write(iulog,*) "JIALEI-AD",ik,const(1,1,ik,imgas_num)
!        end do
!
!      end if  JIALEI DEBUG for ESTER
      
      !const(i1:i2,ju1:j2,:,235)=1.0d-30 
      Deallocate(const_nb)
      Deallocate(clwc_nb)

      return

      end

c-----------------------------------------------------------------------------
c
c ROUTINE
c   Distri_SOA_Par
c
c DESCRIPTION
c   This routine distributes SOA to different types of aerosol

c Author: Guangxing Lin, 2015-03 JIALEI 2016-12

         subroutine Distri_SOA_Par
     &  (pres3c, kel, const,qkimp, qkimp_cld,so2_hete,so2_o3)

      use modpar_umaer, only: pi,radaccu, racculim, naccu, fracaccu,
     &   radgaccu,r0,fraccnon, radgaccnon
      use modbox_umaer, only: so4sig,xnonsig
      use h_umaerosol
      use h_imp_phys_constants
      use h_setkin_par
      use h_imp_dims
      use h_imp_control      
      use cam_logfile,   only: iulog

      implicit none
c     ----------------------
c     Argument declarations.
c     ----------------------
      real*8  :: pres3c(ilo:ihi, julo:jhi, k1:k2)
      real*8  :: kel (ilo:ihi, julo:jhi, k1:k2)
      real*8  :: const (i1:i2,   ju1:j2,   k1:k2, num_species)
      real*8  :: qkimp (i1:i2, ju1:j2, k1:k2, num_qks) ! units:molecues/cm3/time step
      real*8  :: qkimp_cld(i1:i2, ju1:j2, k1:k2, num_qks)
      real*8  :: so2_hete (i1:i2,   ju1:j2,   k1:k2 )
      real*8  :: so2_o3 (i1:i2,   ju1:j2,   k1:k2 )


c     ----------------------
c     Variable declarations.
c     ----------------------

      integer :: idumday, idumyear,k, km1
      integer :: month,il,ij,ik, id, mw_tmp



      logical :: do_trop_chem(i1:i2, ju1:j2, k1:k2)

      real*8  :: air_density(i1:i2, ju1:j2, k1:k2)
      real*8  :: num_so41(i1:i2, ju1:j2, k1:k2)
      real*8  :: num_so42(i1:i2, ju1:j2, k1:k2)
      real*8  :: num_so43(i1:i2, ju1:j2, k1:k2)
      real*8  :: mas_so41(i1:i2, ju1:j2, k1:k2)
      real*8  :: mas_so42(i1:i2, ju1:j2, k1:k2)
      real*8  :: mas_so43(i1:i2, ju1:j2, k1:k2)
      real*8  :: rv_so41(i1:i2, ju1:j2, k1:k2)
      real*8  :: rv_so42(i1:i2, ju1:j2, k1:k2)
      real*8  :: rv_so43(i1:i2, ju1:j2, k1:k2)  !volume mean radius (m)
      real*8  :: rm_so41(i1:i2, ju1:j2, k1:k2)
      real*8  :: rm_so42(i1:i2, ju1:j2, k1:k2)
      real*8  :: rm_so43(i1:i2, ju1:j2, k1:k2) !mode mean radius (cm)
!JIALEI---add num/mas/rv/rm_so43 above
      real*8  :: lbs_sad(i1:i2, ju1:j2, k1:k2)
      real*8  :: lbs_sad_sm1(i1:i2, ju1:j2, k1:k2)
      real*8  :: lbs_sad_sm2(i1:i2, ju1:j2, k1:k2)
      real*8  :: lbs_sad_sm3(i1:i2, ju1:j2, k1:k2)  !JIALEI
      real*8  :: srcmas_cloud(i1:i2, ju1:j2, k1:k2)
      real*8  :: srcmas_uptake(i1:i2, ju1:j2, k1:k2)
      real*8  :: srcmas_parti(i1:i2, ju1:j2, k1:k2)

      real*8  radg_tmp, total, tot_num

      real*8  :: rh(i1:i2, ju1:j2, k1:k2)
      real*8  :: h2osat_3d    (i1:i2, ju1:j2, k1:k2)
      real*8  :: h2ogas_3d    (i1:i2, ju1:j2, k1:k2)
      real*8  :: so4mfrac_3d  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so4dens_3d   (i1:i2, ju1:j2, k1:k2)
      real*8  :: wetmas    (i1:i2, ju1:j2, k1:k2)
      real*8  :: so4aer    (i1:i2, ju1:j2, k1:k2, naer)
      real*8  :: so4radv   (i1:i2, ju1:j2, k1:k2, nso4)
      real*8  :: so4non    (i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: aernon    (i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: xnonum_3d    (i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: xso4non   (i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: fso4non   (i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: rso4min   (i1:i2, ju1:j2, k1:k2)

      real*8  :: fracsrc_tmp(i1:i2, ju1:j2, k1:k2, nso4)
      real*8  :: srcm_cloud(i1:i2, ju1:j2, k1:k2, nso4)
      real*8  :: soa_so4(i1:i2, ju1:j2, k1:k2, nso4)
      real*8  :: fracsrcnon_tmp(i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: srcmnon_cloud(i1:i2, ju1:j2, k1:k2, nnon-4)
      real*8  :: srcmnon_cloud_dis(i1:i2, ju1:j2, k1:k2, 13)!JIALEI add new variable to distribute and store srcmnon_cloud 
      real*8  :: soa_non(i1:i2, ju1:j2, k1:k2, 16)!JIALEI from nnon to 13 !10/2017 change to 16 for organic nucleation
      real*8  :: oa_total(i1:i2, ju1:j2, k1:k2 )
      real*8  :: srcm_uptake(i1:i2, ju1:j2, k1:k2,nso4)
      real*8  :: srcm_parti(i1:i2, ju1:j2, k1:k2,nso4), srcmorg_parti(i1:i2, ju1:j2, k1:k2,norg)
      real*8  :: srcmnon_parti(i1:i2, ju1:j2, k1:k2,13)!JIALEI from nnon to 13 as different speice number
      real*8  :: fsrc(nso4), fsrcnon(nnon-4)
c--------------------JIALEI-----from nnon to (nnon-4) above----------
c     -----------------------
c     Parameter declarations.
c     -----------------------

c      real*8, parameter :: pi = 3.1415926d0
      real*8, parameter :: mw_air = 28.96d0
      real*8, parameter :: rhosul = 1.769d3   !kg/m^3
      real*8, parameter :: sigmod01 = 1.514d0 !sig of so4n1
      real*8, parameter :: sigmod02 = 1.776d0 !sig of so4n2
      real*8, parameter :: sigmod03 = 1.776d0 !sig of so4n3 JIALEI
c
c---->define local arrays and parameter
c
      real*8, parameter :: r5=5.d0
c
c---->add for non-sulfate aerosol that can act as CCN
       integer :: iaccu
       integer :: prod_id_glyac(21),prod_id_osoa(26), prod_id_oxlac(7),
     &   prod_id_prv(6), dest_id_glyac(4), dest_id_oxlac(6),
     &   dest_id_prv(4), id_soa_iepox, id_gsoa, id_mgsoa
       real*8 :: prod_yld_glyac(21), prod_yld_oxlac(7), prod_yld_prv(6)
       real*8 :: mw_osoa(26)

       data prod_id_glyac/696,697,698,753,754,755,758,759,760,761,762,764,
     $ 765,767,768,769,770,771,772,819,820/
       data prod_yld_glyac/1.0,1.0,1.0,0.08,0.08,0.08,0.85,0.85,0.03,0.03,
     & 0.03,1.0,1.0,1.0,1.0,1.0,0.08,0.08,0.08,1.0,1.0/
       data dest_id_glyac/699,700,775,776/

       data prod_id_osoa/537,540,543,546,549,552,555,558,561,564,567,570,
     & 573,576,579,582,585,588,591,594,597,604,607,610,613,616/

       data id_soa_iepox/601/
       data id_gsoa/821/
       data id_mgsoa/822/
       data prod_id_oxlac/699,700,760,761,762,775,776/
       data prod_yld_oxlac/1.0,1.0,0.97,0.97,0.97,1.0,1.0/
       data dest_id_oxlac/701,702,703,777,778,779/
       data prod_id_prv/753,754,755,770,771,772/
       data prod_yld_prv/0.92,0.92,0.92,0.92,0.92,0.92/
       data dest_id_prv/756,757,773,774/

       data mw_osoa/140.10d0,  159.20d0,  172.10d0,
     &  217.10d0,  161.10d0,  137.00d0,  139.10d0,
     &  118.10d0,  175.10d0,  130.10d0,  175.10d0,
     &  130.10d0,  116.00d0,  150.10d0,  231.00d0,!163.10d0,
     &  197.10d0,  186.30d0,  120.10d0,  131.10d0,
     &  186.30d0,  120.10d0,  120.00d0,  120.00d0,
     &  104.00d0,  136.00d0,  137.00d0/


c     -----------------------------------------------------------
c     Calculate relative humidity from Seinfeld (1986) p. 181.
c     The first rh is the temperature dependent parameter a.
c     The second rh is the saturation vapor pressure of water.
c     The third rh is the actual relative humidity as a fraction.
c     Then make sure rh is between 0 and 1.
c     -----------------------------------------------------------

      rh(:,:,:) = 1.0d0 - (373.15d0 / kel(i1:i2,ju1:j2,:))

      rh(:,:,:) =
     &  1013.25d0 * Exp (13.3185d0 * rh(:,:,:)    -
     &                    1.9760d0 * rh(:,:,:)**2 -
     &                    0.6445d0 * rh(:,:,:)**3 -
     &                    0.1299d0 * rh(:,:,:)**4)

      rh(:,:,:) =
     &  const(:,:,:,ih2o_num) *
     &  pres3c(i1:i2,ju1:j2,:) / rh(:,:,:)

      rh(:,:,:) = Max (Min (rh(:,:,:), 1.0d0), 0.0d0)


c-----------------------------------------------------------------------------
c     Calculate the surface area density based on the mass, number concentration
c     and size distribution of sulfate.
c----------------------------------------------------------------------------

c     calculate the air density in units kg/m^3

      air_density(:,:,:) = const(:,:,:,imgas_num) *
     &  1.0d6 * 28.96d0 * 1.0d-3 / 6.022d23

c     get SO4 number concentraion and mass concentration

      num_so41(:,:,:) = const(:,:,:,ISO4N1 ) * air_density(:,:,:)     !#/m^3
      num_so42(:,:,:) = const(:,:,:,ISO4N2 ) * air_density(:,:,:)     !#/m^3
      num_so43(:,:,:) = const(:,:,:,ISO4N3 ) * air_density(:,:,:)     !#/m^3  !JIALEI
      mas_so41(:,:,:) = const(:,:,:,ISO4M1 ) * air_density(:,:,:)     !kg/m^3
      mas_so42(:,:,:) = const(:,:,:,ISO4M2 ) * air_density(:,:,:)     !kg/m^3
      mas_so43(:,:,:) = const(:,:,:,ISO4M3 ) * air_density(:,:,:)     !kg/m^3  !JIALEI

c    get volume mean radius (m)

      rv_so41(:,:,:) = (3.d0 * mas_so41(:,:,:) /max(num_so41(:,:,:),r1)/
     &     (4.d0 * pi * rhosul)) ** (1.d0/3.d0)
      rv_so42(:,:,:) = (3.d0 * mas_so42(:,:,:) /max(num_so42(:,:,:),r1)/
     &     (4.d0 * pi * rhosul)) ** (1.d0/3.d0)
      rv_so43(:,:,:) = (3.d0 * mas_so43(:,:,:) /max(num_so43(:,:,:),r1)/
     &     (4.d0 * pi * rhosul)) ** (1.d0/3.d0)   !JIALEI

c    get mode radius (m)

      rm_so41(:,:,:) = rv_so41(:,:,:) * exp(-3.d0 *
     $  log(sigmod01) ** 2.d0 / 2.d0 )
      rm_so42(:,:,:) = rv_so42(:,:,:) * exp(-3.d0 *
     $  log(sigmod02) ** 2.d0 / 2.d0 )
      rm_so43(:,:,:) = rv_so43(:,:,:) * exp(-3.d0 *
     $  log(sigmod03) ** 2.d0 / 2.d0 )  !JIALEI

c    change units (m-->cm)
      rm_so41(:,:,:) = rm_so41(:,:,:) * 1.d2
      rm_so42(:,:,:) = rm_so42(:,:,:) * 1.d2
      rm_so43(:,:,:) = rm_so43(:,:,:) * 1.d2 !JIALEI
c    get SO4 area density (cm^2/cm^3)

      lbs_sad(:,:,:) = 4.d0 * pi * rm_so41(:,:,:)
     &   ** 2.d0 * num_so41(:,:,:) * 1.d-6
     &   +4.d0 * pi * rm_so42(:,:,:) ** 2.d0 * num_so42(:,:,:) * 1.d-6
     &   +4.d0 * pi * rm_so43(:,:,:) ** 2.d0 * num_so43(:,:,:) * 1.d-6 !JIALEI

       lbs_sad_sm1(:,:,:) = 4.d0 * pi * rm_so41(:,:,:)
     &   ** 2.d0 * num_so41(:,:,:) * 1.d-6
       lbs_sad_sm2(:,:,:) = 4.d0 * pi * rm_so42(:,:,:)
     &   ** 2.d0 * num_so42(:,:,:) * 1.d-6
       lbs_sad_sm3(:,:,:) = 4.d0 * pi * rm_so43(:,:,:)
     &   ** 2.d0 * num_so43(:,:,:) * 1.d-6  !JIALEI
     
      do il = i1, i2
        do ij = ju1, j2
          do ik = k1, k2
            srcmas_cloud(il,ij,ik)=0.0d0
            mw_tmp=74.0
            do id=1,21
c      #/cm3 / #/cm3 = #/# = vol/vol
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) +
     &      qkimp(il,ij,ik,prod_id_glyac(id))*prod_yld_glyac(id)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do
            do id=1,4
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) -
     &      qkimp(il,ij,ik,dest_id_glyac(id))
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do
c      oxalic acid

            mw_tmp=90.0
            do id=1,7
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) +
     &      qkimp(il,ij,ik,prod_id_oxlac(id))*prod_yld_oxlac(id)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do

            do id=1,6
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) -
     &      qkimp(il,ij,ik,dest_id_oxlac(id))
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do

c      pyruvic acid
            mw_tmp=88.0
            do id=1,6
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) +
     &      qkimp(il,ij,ik,prod_id_prv(id))*prod_yld_prv(id)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do

            do id=1,4
       srcmas_cloud(il,ij,ik)=srcmas_cloud(il,ij,ik) -
     &      qkimp(il,ij,ik,dest_id_prv(id))
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
            end do


c     SOA from the uptake of glyoxal, methylglyoxal and epoxide on sulfate
          srcmas_uptake(il,ij,ik)=0.0d0
c          epoxide
           mw_tmp=116.0
       srcmas_uptake(il,ij,ik)=srcmas_uptake(il,ij,ik) +
     &      qkimp(il,ij,ik,id_soa_iepox)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg

c----------temporary output-----
        so2_o3(il,ij,ik)=qkimp(il,ij,ik,id_soa_iepox)
c          glyoxal
           mw_tmp=58.0
       srcmas_uptake(il,ij,ik)=srcmas_uptake(il,ij,ik) +
     &      qkimp(il,ij,ik,id_gsoa)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
c          methylglyoxal
           mw_tmp=72.0
       srcmas_uptake(il,ij,ik)=srcmas_uptake(il,ij,ik) +
     &      qkimp(il,ij,ik,id_mgsoa)
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg
c========temporay output=============
      so2_hete(il,ij,ik)=so2_hete(il,ij,ik)+srcmas_uptake(il,ij,ik)

c     SOA from gas-particle partitioning
          srcmas_parti(il,ij,ik)=0.0d0
            mw_tmp=150.0
            do id=1,26
       srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
     &     ( qkimp(il,ij,ik,(prod_id_osoa(id)-2))
     &-qkimp(il,ij,ik,(prod_id_osoa(id)-1))-qkimp(il,ij,ik,prod_id_osoa(id)))
     &      /const(il,ij,ik,imgas_num)*mw_osoa(id)/mw_air ! m3/m3->kg/kg !ev_oSOA

       srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
     &     ( qkimp(il,ij,ik,prod_id_osoa(id)))
     &      /const(il,ij,ik,imgas_num)*mw_tmp/mw_air ! m3/m3->kg/kg  !ne_oSOA
           end do 

c-------------------------JIALEI new chem version-----------
              
!        srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
!     &     ( qkimp(il,ij,ik,826)+ qkimp(il,ij,ik,827)- qkimp(il,ij,ik,829)
!     &     +qkimp(il,ij,ik,846))
!     &      /const(il,ij,ik,imgas_num)*186/mw_air ! m3/m3->kg/kg  !PINIC
               
!              srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
!     &     ( qkimp(il,ij,ik,853))
!     &      /const(il,ij,ik,imgas_num)*326/mw_air ! m3/m3->kg/kg !ESTER

!              srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
!     &     ( qkimp(il,ij,ik,96)+qkimp(il,ij,ik,405)+qkimp(il,ij,ik,407)+
!     &       qkimp(il,ij,ik,860)-qkimp(il,ij,ik,864)-qkimp(il,ij,ik,865)
!     &       -qkimp(il,ij,ik,866))
!     &      /const(il,ij,ik,imgas_num)*215/mw_air ! m3/m3->kg/kg  !MONITU

!              srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
!     &     ( qkimp(il,ij,ik,96)+qkimp(il,ij,ik,113)+qkimp(il,ij,ik,200)+
!     &       qkimp(il,ij,ik,405)+qkimp(il,ij,ik,858)+qkimp(il,ij,ik,860)
!     &       -qkimp(il,ij,ik,863)-qkimp(il,ij,ik,867))
!     &      /const(il,ij,ik,imgas_num)*215/mw_air ! m3/m3->kg/kg  !MONITS

              srcmas_parti(il,ij,ik)=srcmas_parti(il,ij,ik) +
     &     ( qkimp(il,ij,ik,863)+qkimp(il,ij,ik,864)+qkimp(il,ij,ik,865)+
     &       qkimp(il,ij,ik,866)+qkimp(il,ij,ik,867)-qkimp(il,ij,ik,870)-
     &       qkimp(il,ij,ik,871))
     &      /const(il,ij,ik,imgas_num)*231/mw_air ! m3/m3->kg/kg  !HONIT



c-------temporay output------

c        const(il,ij,ik,ISOASM1)=const(il,ij,ik,ISOASM1)+srcmas_parti(il,ij,ik)  
c        const(il,ij,ik,ISOASM2)=const(il,ij,ik,ISOASM2)+srcmas_uptake(il,ij,ik)
c        const(il,ij,ik,ISOASM3)=const(il,ij,ik,ISOASM3)+srcmas_cloud(il,ij,ik)

         so2_hete(il,ij,ik)=so2_hete(il,ij,ik)+srcmas_parti(il,ij,ik)
c     &      const(il,ij,ik,imgas_num)/mw_tmp*mw_air
c         so2_hete(il,ij,ik)=0.0d0
          end do ! ik
         end do! ij
        end do ! il

      !goto 2222 OK
c  For  SOA formed in the cloud water (organic acids). It is distributed to different
c  types of aerosol based on the number of CCN that can be formed, just following the
c  same way used for sulfate

c  First calulate the CCN number for each aerosol

c   Sulfate aerosol

cc    compute so4 aerosol size (m)


      so4aer(:,:,:,1) = const(:,:,:,ISO4M1)
      so4aer(:,:,:,2) = const(:,:,:,ISO4N1)
      so4aer(:,:,:,3) = const(:,:,:,ISO4M2)
      so4aer(:,:,:,4) = const(:,:,:,ISO4N2)
      so4aer(:,:,:,5) = const(:,:,:,ISO4M3)  !JIALEI
      so4aer(:,:,:,6) = const(:,:,:,ISO4N3)  !JIALEI

      do il = i1, i2
        do ij = ju1, j2
          do ik = k1, k2
            h2osat_3d(il,ij,ik) = h2osat_f(kel(il,ij,ik))
            h2ogas_3d(il,ij,ik) = rh(il,ij,ik)*h2osat_3d(il,ij,ik)

            so4mfrac_3d(il,ij,ik) = so4mfrac_f(kel(il,ij,ik),
     &                                      h2osat_3d(il,ij,ik),
     &                                      h2ogas_3d(il,ij,ik))
            so4dens_3d(il,ij,ik) = so4dens_f(kel(il,ij,ik),
     &                                    so4mfrac_3d(il,ij,ik))
          end do
        end do
      end do

      do iso4 = 1, nso4

        iso4n = iso4 * nmomso4
        iso4m = iso4n - 1

        wetmas(:,:,:) = max(r2so4min, so4aer(:,:,:,iso4m)
     &                / max(epsilo,   so4aer(:,:,:,iso4n)))
     &                / so4mfrac_3d(:,:,:)

        so4radv(:,:,:,iso4) = (r3q * wetmas(:,:,:)
     &                      / (IMP_PI * so4dens_3d(:,:,:)))**r1td
        so4radv(:,:,:,iso4) = max(so4radvmin,
     &                        min(so4radv(:,:,:,iso4),so4radvmax))

      end do

c----------distribution for Sulfate CCN

      do iso4=1,nso4
       iso4n=iso4*nmomso4
c       do iv=1,nv
c      so4sig =sigmod=/1.514d0,1.77623d0/ in umaerosol.h
      do il = i1, i2
        do ij = ju1, j2
          do ik = k1, k2
        radg_tmp=so4radv(il,ij,ik,iso4)*exp(-r3h*log(so4sig(1,iso4))**2)
        if (r5*so4sig(1,iso4)*radg_tmp>radaccu(1)) then
c       radaccu, radgaccu,fracaccu, and racculim are set values in modinit_umaer.F
         if (radg_tmp<racculim) then
          do iaccu=1,naccu
           if (radgaccu(iaccu,iso4,1)>radg_tmp) exit
          enddo
          k=iaccu
          km1=k-1
          fracsrc_tmp(il,ij,ik,iso4)=so4aer(il,ij,ik,iso4n)
     $         *(fracaccu(km1,iso4)*(radgaccu(k  ,iso4,1)-radg_tmp)
     $          -fracaccu(k  ,iso4)*(radgaccu(km1,iso4,1)-radg_tmp))
     $         /(radgaccu(k  ,iso4,1)-radgaccu(km1,iso4,1))
         else
          do iaccu=1,naccu
           if (radgaccu(iaccu,iso4,2)<=radg_tmp) exit
          enddo
          k=iaccu
          km1=k-1
       fracsrc_tmp(il,ij,ik,iso4)=so4aer(il,ij,ik,iso4n)
     $         *(fracaccu(km1,iso4)*(radgaccu(k  ,iso4,2)-radg_tmp)
     $          -fracaccu(k  ,iso4)*(radgaccu(km1,iso4,2)-radg_tmp))
     $         /(radgaccu(k  ,iso4,2)-radgaccu(km1,iso4,2))
         endif
        else
         fracsrc_tmp(il,ij,ik,iso4)=r0
        endif
c       enddo
        end do !ik
       end do! ij
      end do!il
      enddo
c
c---->non-sulfate aerosol
c
      so4non(:,:,:,1:nnon-4) = const(:,:,:,ISO4NOC:ISO4S4) !need to change nnon?
      aernon(:,:,:,1:nnon-4) = const(:,:,:,INOC:ISSLT4)

cc    non-so4 aerosol radius (m) and mass (kg/particle)
      do inon = 1, nnon-4

        radvolm(:) = radgnon(:,inon)
     &             * exp(r3h*log(siggnon(:,inon))**2)
        radvnon(inon) = sum(fracnon(:,inon)*radvolm(:)**3) !the same as radvnon above?
        pmsnon(inon) = r4td*IMP_PI*rhonon(inon)
     &               * radvnon(inon)
        radvnon(inon) = radvnon(inon)**r1td

      end do
c-------non-so4 aerosol number concentration (#particles/kg air)
      do inon = 1, nnon-4
        xnonum_3d(:,:,:,inon) = aernon(:,:,:,inon) / pmsnon(inon)
      end do
      do inon=1,nnon-4
c       do iv=1,nv
c      xnonsig(:,inon) for all iv has the same value, so I pick the one for iv=1
        radg_tmp=radvnon(inon)*exp(-r3h*log(xnonsig(1,inon))**2)
        if (xnonsig(1,inon)<=r1) then
          if (radg_tmp>radaccu(1)) then
           fracsrcnon_tmp(:,:,:,inon)=xnonum_3d(:,:,:,inon)
          else
           fracsrcnon_tmp(:,:,:,inon)=r0
          endif
        else
          if (r5*xnonsig(1,inon)*radg_tmp>radaccu(1)) then
            do iaccu=1,naccu
             if (radgaccnon(iaccu,inon)>radg_tmp) exit
            enddo
            k=iaccu
            km1=k-1
            fracsrcnon_tmp(:,:,:,inon)=xnonum_3d(:,:,:,inon)
     $           *(fraccnon(km1)*(radgaccnon(k  ,inon)-radg_tmp)
     $            -fraccnon(k  )*(radgaccnon(km1,inon)-radg_tmp))
     $           /(radgaccnon(k,inon)-radgaccnon(km1,inon))
          else
          fracsrcnon_tmp(:,:,:,inon)=r0
          endif
        endif
c       enddo
      enddo

c      write(iulog,*) 'JIALEI begin        = NUM_Kistribution1'

cc    so4 molecule # on non-so4 aerosol surface (#molec/particle)
      xso4non(:,:,:,1:nnon-4) = max(1.0d-30,so4non(:,:,:,1:nnon-4)) /
     &  max(r1,xnonum_3d(:,:,:,1:nnon-4)) / so4min

cc    radius of each so4 molecule (m)
      rso4min(:,:,:) =
     &  (so4min * r3q /
     &  (IMP_PI*so4mfrac_3d(:,:,:)*so4dens_3d(:,:,:)))**r1td

cc    area fraction of so4 molecules on non-so4 aerosol surface
      do inon = 1, nnon-4

        fso4non(:,:,:,inon) =
     &    rso4min(:,:,:)**2.0d0 * xso4non(:,:,:,inon)
     &    / (4.0d0*(radvnon(inon)+rso4min(:,:,:))**2.0d0)

      end do

c---->non-sulfate aerosol that can act as CCN
      do inon=1,nnon-4
c        do iv=1,nv
          if (inon<=nnon-4) then  !JIALEI why nnon-4 originally
            fracsrcnon_tmp(:,:,:,inon)=fracsrcnon_tmp(:,:,:,inon)
     $                         *min(fso4non(:,:,:,inon)/fso4crit,r1)
          endif
c        enddo
      enddo
c      write(iulog,*) 'JIALEI begin Distribution2'
cc    fraction of CCN number for each aerosol type
c----------Distribute SOA formed in the cloud water-------
      do il = i1, i2
        do ij = ju1, j2
          do ik = k1, k2
        total=sum(fracsrc_tmp(il,ij,ik,1:nso4))+
     $   sum(fracsrcnon_tmp(il,ij,ik,2:nnon-4))
c-----------if there is CCN, distribute the SOA based on the number of
c       CCN that can be formed.
       if (total>r0)then   !JIALEI from r1 to r0?
        fsrc(1:nso4)=fracsrc_tmp(il,ij,ik,1:nso4)/total
        fsrcnon(2:nnon-4)=fracsrcnon_tmp(il,ij,ik,2:nnon-4)/total
        srcm_cloud(il,ij,ik,1:nso4)=fsrc(1:nso4)*srcmas_cloud(il,ij,ik)
        srcmnon_cloud(il,ij,ik,2:nnon-4)=
     $       fsrcnon(2:nnon-4)*srcmas_cloud(il,ij,ik)
c        srcg=r0
       else
c        srcg=srcmas(iv)
        srcm_cloud(il,ij,ik,:)=r0
        srcmnon_cloud(il,ij,ik,:)=r0
       endif

c------if there is no CCN, distribute the SOA based on the particle number concentration,
c      assuming that the cloud SOA will eveaporate and condense on non-SOA aerosols.


       if(srcmas_cloud(il,ij,ik).gt.r0.and.total.eq.r0) then
c       write(iulog,*) 'Total=',total
          tot_num=max((so4aer(il,ij,ik,2)+so4aer(il,ij,ik,4)+
     &   so4aer(il,ij,ik,6)+sum(xnonum_3d(il,ij,ik,2:nnon-4))),r1)  !JIALEI add (so4aer(il,ij,ik,6)

        srcm_cloud(il,ij,ik,1)=so4aer(il,ij,ik,2)/tot_num
     &    *srcmas_cloud(il,ij,ik)
        srcm_cloud(il,ij,ik,2)=so4aer(il,ij,ik,4)/tot_num
     &    *srcmas_cloud(il,ij,ik)
        srcm_cloud(il,ij,ik,3)=so4aer(il,ij,ik,6)/tot_num
     &    *srcmas_cloud(il,ij,ik)  !JIALEI
        srcmnon_cloud(il,ij,ik,2:nnon-4)=xnonum_3d(il,ij,ik,2:nnon-4)
     &    /tot_num*srcmas_cloud(il,ij,ik)
        end if

         end do ! ik
        end do ! ij
       end do ! il

      
c      write(iulog,*) 'JIALEI begin Distribution3',ISOAnOC

c----Distribute SOA from thermodynamic approach------------
c    distribute ev_oSOA and ne_oSOA based on pre-existing OA mass
         soa_so4(:,:,:,1:nso4)=const(:,:,:,ISOASM1:ISOASM3) !JIALEI

         soa_non(:,:,:,2:16)=const(:,:,:,ISOAnOC+1:ISOAOM3)
c    got to add POA mass as well
!         soa_non(:,:,:,1) = soa_non(:,:,:,1) + const(:,:,:,INOC)
         soa_non(:,:,:,2) = soa_non(:,:,:,2) + const(:,:,:,IFOC)
     & + const(:,:,:,IOCPHl1) + const(:,:,:,IOCPHl2) !JIALEI
         soa_non(:,:,:,4) = soa_non(:,:,:,4) + const(:,:,:,IBOC)
!-----------JIALEI for nucleation version
         soa_non(:,:,:,14) = soa_non(:,:,:,14) + const(:,:,:,IORGM1)+ const(:,:,:,ISOAOM1)
         soa_non(:,:,:,15) = soa_non(:,:,:,15) + const(:,:,:,IORGM2)+ const(:,:,:,ISOAOM2)
         soa_non(:,:,:,16) = soa_non(:,:,:,16) + const(:,:,:,IORGM3)+ const(:,:,:,ISOAOM3)


        oa_total(:,:,:)=1.0d-30
         do iso4 = 1, nso4
            oa_total(:,:,:)=oa_total(:,:,:)+ soa_so4(:,:,:,iso4)
         end do
         do inon=2, 16 !JIALEI !remove nOC
            oa_total(:,:,:)=oa_total(:,:,:)+ soa_non(:,:,:,inon)
         end do
         do iso4 = 1, nso4
        srcm_parti(:,:,:,iso4)=srcmas_parti(:,:,:)*soa_so4(:,:,:,iso4)
     $      /oa_total(:,:,:)
         end do
c      write(iulog,*) 'JIALEI begin Distribution4',nnon

        do inon=2, 13 
        srcmnon_parti(:,:,:,inon)=srcmas_parti(:,:,:)*soa_non(:,:,:,inon)
     $      /oa_total(:,:,:)
        end do
!------------JIALEI for nucleation version------------
        do inon=14,16 !JIALEI
        srcmorg_parti(:,:,:,inon-13)=srcmas_parti(:,:,:)*soa_non(:,:,:,inon)
     $      /oa_total(:,:,:)
        end do
c-----------------------------------------------------------------------------
c--------------------Distribute SOA from kinetic approach to Sulfate----
        srcm_uptake(:,:,:,1)=srcmas_uptake(:,:,:)*lbs_sad_sm1(:,:,:)
     $      /lbs_sad(:,:,:)
        srcm_uptake(:,:,:,2)=srcmas_uptake(:,:,:)*lbs_sad_sm2(:,:,:)
     $      /lbs_sad(:,:,:)
        srcm_uptake(:,:,:,3)=srcmas_uptake(:,:,:)*lbs_sad_sm3(:,:,:)
     $      /lbs_sad(:,:,:) !JIALEI

      
c---------------JIALEI----Distribute srcmnon_cloud to srcmnon_cloud_dis
c---------Fit the 13 species of SOA

      srcmnon_cloud_dis(:,:,:,1)=srcmnon_cloud(:,:,:,1)
      srcmnon_cloud_dis(:,:,:,2)=srcmnon_cloud(:,:,:,2)
     & +srcmnon_cloud(:,:,:,6)+srcmnon_cloud(:,:,:,7)
      srcmnon_cloud_dis(:,:,:,3)=srcmnon_cloud(:,:,:,3)
     & +srcmnon_cloud(:,:,:,8)+srcmnon_cloud(:,:,:,9)
      srcmnon_cloud_dis(:,:,:,4)=srcmnon_cloud(:,:,:,4)
      srcmnon_cloud_dis(:,:,:,5)=srcmnon_cloud(:,:,:,5)
      srcmnon_cloud_dis(:,:,:,6:13)=srcmnon_cloud(:,:,:,14:21)


c-----------------------------------------------------------------------
!      goto 2222
c      write(iulog,*) 'JIALEI begin Distribution4.2',ISOAnOC,ISOASM1

        do inon=2, 13 !JIALEI
      const(:,:,:,ISOAnOC + inon-1)=const(:,:,:,ISOAnOC +inon-1)+
     &       srcmnon_parti(:,:,:,inon) + srcmnon_cloud_dis(:,:,:,inon)
        end do
         do iso4 = 1, nso4
      const(:,:,:,ISOASM1+iso4-1)=const(:,:,:,ISOASM1+iso4-1)+
     &       srcm_parti(:,:,:,iso4) + srcm_cloud(:,:,:,iso4) +
     &       srcm_uptake(:,:,:,iso4)
        end do

        do inon=1, 3 !JIALEI
      const(:,:,:,ISOAOM1 + inon-1)=const(:,:,:,ISOAOM1 +inon-1)+
     &       srcmorg_parti(:,:,:,inon)
        end do

      where(const(:,:,:,ISOASM1:ISOAOM3).lt.1.0E-30) const(:,:,:,ISOASM1:ISOAOM3)=1.0E-30



2222   continue
       return

       end

