          module h_setkin_lchem
          
          use h_setkin_par, only: NSP, NDYN, NUM_K, NUM_J
          implicit none
          public 
c=======================================================================
c
c $Id: setkin_lchem.h,v 1.3 2002/02/20 15:38:31 akinorii Exp $
c
c FILE
c   setkin_lchem.h - character labels for species and reactions
c             (setkin_lchem.h)
c   10 JUN 98 - PSC
c
c DESCRIPTION
c   Include file that provides ascii strings identifying reactions
c   and species
c
c  Chemistry input file generated: 2/23/00 10:12AM
c  Reaction dictionary:            3/29/99 2:55PM
c  Setkin files generated:         Wed Feb 23 10:30:41 2000
c
c   "setkin_lchem.h" was modified for sulfchem by Xiaohong Liu
c
c=======================================================================


      integer i

      character*16, save :: lchemvar(NSP),  ldynvar(NDYN)
      character*80, save :: lqkchem(NUM_K), lqjchem(NUM_J)
c
c.... All species labels
c
      data lchemvar(1) /"H2O2_su"/    ! Not used
      data lchemvar(2) /"fSO2"/
      data lchemvar(3) /"nSO2"/
      data lchemvar(4) /"nDMS"/
      data lchemvar(5) /"SO4g"/
      data lchemvar(6) /"SO4m1"/
      data lchemvar(7) /"SO4n1"/
      data lchemvar(8) /"SO4m2"/
      data lchemvar(9) /"SO4n2"/
      data lchemvar(10) /"SO4m3"/
      data lchemvar(11) /"SO4n3"/
      data lchemvar(12) /"SO4nOC"/
      data lchemvar(13) /"SO4fOC"/
      data lchemvar(14) /"SO4fBC"/
      data lchemvar(15) /"SO4bOC"/
      data lchemvar(16) /"SO4bBC"/
      data lchemvar(17) /"SO4OC1"/
      data lchemvar(18) /"SO4OC2"/
      data lchemvar(19) /"SO4BC1"/
      data lchemvar(20) /"SO4BC2"/
      data lchemvar(21) /"SO4cPOM"/
      data lchemvar(22) /"SO4cBC"/
      data lchemvar(23) /"SO4aPOM"/
      data lchemvar(24) /"SO4aBC"/
      data lchemvar(25) /"SO4d1"/
      data lchemvar(26) /"SO4d2"/
      data lchemvar(27) /"SO4d3"/
      data lchemvar(28) /"SO4d4"/
      data lchemvar(29) /"SO4s1"/
      data lchemvar(30) /"SO4s2"/
      data lchemvar(31) /"SO4s3"/
      data lchemvar(32) /"SO4s4"/
      data lchemvar(33) /"nOC"/
      data lchemvar(34) /"fOC"/
      data lchemvar(35) /"fBC"/
      data lchemvar(36) /"bOC"/
      data lchemvar(37) /"bBC"/
      data lchemvar(38) /"fOC1"/
      data lchemvar(39) /"fOC2"/
      data lchemvar(40) /"fBC1"/
      data lchemvar(41) /"fBC2"/
      data lchemvar(42) /"cPOM"/
      data lchemvar(43) /"cBC"/
      data lchemvar(44) /"aPOM"/
      data lchemvar(45) /"aBC"/
      data lchemvar(46) /"dust1"/
      data lchemvar(47) /"dust2"/
      data lchemvar(48) /"dust3"/
      data lchemvar(49) /"dust4"/
      data lchemvar(50) /"sslt1"/
      data lchemvar(51) /"sslt2"/
      data lchemvar(52) /"sslt3"/
      data lchemvar(53) /"sslt4"/
      data lchemvar(54) /"aSO2"/
      data lchemvar(55) /"aSO4"/
      data lchemvar(56) /"aH2O"/
      data lchemvar(57) /"SO4oSO"/    
      data lchemvar(58) /"SO4GLY"/    
      data lchemvar(59) /"SO4MGL"/    
      data lchemvar(60) /"SO4IEP"/    
      data lchemvar(61) /"ad_su"/    ! Not used
      data lchemvar(62) /"O3"/
      data lchemvar(63) /"NO2"/
      data lchemvar(64) /"NO"/
      data lchemvar(65) /"NO3"/
      data lchemvar(66) /"N2O5"/
      data lchemvar(67) /"HNO3"/
      data lchemvar(68) /"HONO"/
      data lchemvar(69) /"HNO4"/
      data lchemvar(70) /"OH"/
      data lchemvar(71) /"HO2"/
      data lchemvar(72) /"H2O2"/
      data lchemvar(73) /"SO2"/
      data lchemvar(74) /"HSO4"/
      data lchemvar(75) /"H2O"/
      data lchemvar(76) /"CO"/
      data lchemvar(77) /"nmhc"/
      data lchemvar(78) /"CH4"/
      data lchemvar(79) /"C2H6"/
      data lchemvar(80) /"C3H8"/
      data lchemvar(81) /"ALK4"/
      data lchemvar(82) /"ALK7"/
      data lchemvar(83) /"HCHO"/
      data lchemvar(84) /"ALD2"/
      data lchemvar(85) /"RCHO"/
      data lchemvar(86) /"ACET"/
      data lchemvar(87) /"MEK"/
      data lchemvar(88) /"ETHE"/
      data lchemvar(89) /"PRPE"/
      data lchemvar(90) /"BUTE"/
      data lchemvar(91) /"ISOP"/
      data lchemvar(92) /"BENZ"/
      data lchemvar(93) /"TOLU"/
      data lchemvar(94) /"XYLE"/
      data lchemvar(95) /"MCO3"/
      data lchemvar(96) /"PAN"/
      data lchemvar(97) /"nco3"/
      data lchemvar(98) /"PPN"/
      data lchemvar(99) /"MO2"/
      data lchemvar(100) /"ETO2"/
      data lchemvar(101) /"ro2"/
      data lchemvar(102) /"rno2"/
      data lchemvar(103) /"ino3"/
      data lchemvar(104) /"rno3"/
      data lchemvar(105) /"npan"/
      data lchemvar(106) /"MPAN"/
      data lchemvar(107) /"PRPN"/
      data lchemvar(108) /"GLYC"/
      data lchemvar(109) /"IALD"/
      data lchemvar(110) /"HAC"/
      data lchemvar(111) /"GLYX"/
      data lchemvar(112) /"MGLY"/
      data lchemvar(113) /"A-DI"/
      data lchemvar(114) /"PHEN"/
      data lchemvar(115) /"CRES"/
      data lchemvar(116) /"DMP"/
      data lchemvar(117) /"POXY"/
      data lchemvar(118) /"DIAL"/
      data lchemvar(119) /"ADAL"/
      data lchemvar(120) /"MDAL"/
      data lchemvar(121) /"ACHO"/
      data lchemvar(122) /"MVK"/
      data lchemvar(123) /"MACR"/
      data lchemvar(124) /"IPRD"/
      data lchemvar(125) /"HACN"/
      data lchemvar(126) /"rioh"/
      data lchemvar(127) /"crig"/
      data lchemvar(128) /"ACO2"/
      data lchemvar(129) /"ACTA"/
      data lchemvar(130) /"RCOH"/
      data lchemvar(131) /"ROH"/
      data lchemvar(132) /"MOH"/
      data lchemvar(133) /"EOH"/
      data lchemvar(134) /"DMS"/
      data lchemvar(135) /"H2"/
      data lchemvar(136) /"MP"/
      data lchemvar(137) /"rooh"/
      data lchemvar(138) /"APIN"/
      data lchemvar(139) /"LIMO"/
      data lchemvar(140) /"AHO2"/
      data lchemvar(141) /"rmoh"/
c-------------gxlin-------------------

      data lchemvar(142) /"PIP"/
c-----------gxlin------------------
      data lchemvar(143) /"MNO3"/
      data lchemvar(144) /"NITP"/
      data lchemvar(145) /"ISNP"/
      data lchemvar(146) /"INPN"/
      data lchemvar(147) /"PRN2"/
      data lchemvar(148) /"ISNT"/
      data lchemvar(149) /"PINT"/

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** Changed to include secondary organic aerosols
c---------------------gxlin-----------------
      data lchemvar(150) /"AD2P"/
      data lchemvar(151) /"APAN"/
      data lchemvar(152) /"DPAN"/
      data lchemvar(153) /"GPAN"/
      data lchemvar(154) /"XAP"/
      data lchemvar(155) /"ZAP"/
      data lchemvar(156) /"AP"/
      data lchemvar(157) /"XPAN"/
      data lchemvar(158) /"YAP"/
      data lchemvar(159) /"YPAN"/
      data lchemvar(160) /"ZPAN"/
      data lchemvar(161) /"IAP"/
      data lchemvar(162) /"LIP"/
      data lchemvar(163) /"MRP"/
      data lchemvar(164) /"VRP"/

      data lchemvar(165) /"RIO2a"/
      data lchemvar(166) /"RIO2b"/
      data lchemvar(167) /"Z1OH1P"/
      data lchemvar(168) /"RIPOH"/
      data lchemvar(169) /"IEPOX"/
      data lchemvar(170) /"TRIOL"/
      data lchemvar(171) /"IAO2"/
      data lchemvar(172) /"Z1CHO"/
      data lchemvar(173) /"IAO2P1"/
      data lchemvar(174) /"DB1OOH"/
      data lchemvar(175) /"DB2OOH"/
      data lchemvar(176) /"C3O3H6"/
      data lchemvar(177) /"GLYHY1g"/
      data lchemvar(178) /"GLYHY2g"/
      data lchemvar(179) /"SO5G"/
      data lchemvar(180) /"HSOG"/
      data lchemvar(181) /"CO3"/
      data lchemvar(182) /"MGLHY1g"/
      data lchemvar(183) /"NH3"/
      data lchemvar(184) /"PRV"/
      data lchemvar(185) /"MGLOLIg"/
      data lchemvar(186) /"MGSOA1g"/
      data lchemvar(187) /"GLYAC"/
      data lchemvar(188) /"OXLAC"/
      data lchemvar(189) /"GLYOLIg"/
      data lchemvar(190) /"GSOA1g"/
      data lchemvar(191) /"ne_oSOA"/
      data lchemvar(192) /"n_IEPOX"/
      data lchemvar(193) /"ev_A-DI"/
      data lchemvar(194) /"ev_AD2P"/
      data lchemvar(195) /"ev_AP"/
      data lchemvar(196) /"ev_APAN"/
      data lchemvar(197) /"ev_DPAN"/
      data lchemvar(198) /"ev_GPAN"/
      data lchemvar(199) /"ev_NITP"/
      data lchemvar(200) /"ev_XAP"/
      data lchemvar(201) /"ev_XPAN"/
      data lchemvar(202) /"ev_YAP"/
      data lchemvar(203) /"ev_YPAN"/
      data lchemvar(204) /"ev_ZAP"/
      data lchemvar(205) /"ev_ZPAN"/
      data lchemvar(206) /"ev_IAP"/
      data lchemvar(207) /"ev_INPN"/
      data lchemvar(208) /"ev_ISNP"/
      data lchemvar(209) /"ev_LIP"/ 
      data lchemvar(210) /"ev_MRP"/
      data lchemvar(211) /"ev_PINT"/
      data lchemvar(212) /"ev_PIP"/
      data lchemvar(213) /"ev_VRP"/
      data lchemvar(214) /"ev_PRN2"/
      data lchemvar(215) /"ev_RIP"/
      data lchemvar(216) /"ev_DB1H"/
      data lchemvar(217) /"ev_DB2H"/
      data lchemvar(218) /"e_TRIOL"/
      data lchemvar(219) /"SO4G"/
c ** End of modificatons by Luis Olcese, UM
c ********************************************
c-------------JIALEI--06/2017-----
      data lchemvar(220) /"C109OOH"/
      data lchemvar(221) /"C109O2"/
      data lchemvar(222) /"C89CO3"/
      data lchemvar(223) /"C811CO3"/
      data lchemvar(224) /"PINIC"/
      data lchemvar(225) /"DIACYLP"/
      data lchemvar(226) /"APINBOO"/
      data lchemvar(227) /"C109OH"/
      data lchemvar(228) /"C109CO"/
      data lchemvar(229) /"C89PAN"/
      data lchemvar(230) /"C89CO3H"/
      data lchemvar(231) /"C89CO2H"/
      data lchemvar(232) /"C811CO3H"/
      data lchemvar(233) /"PINAL"/
      data lchemvar(234) /"PINONIC"/
      data lchemvar(235) /"ESTER"/
      data lchemvar(236) /"C811PAN"/
c-------------JIALEI--08/2018-----
      data lchemvar(237) /"MONITS"/
      data lchemvar(238) /"MONITU"/
      data lchemvar(239) /"HONIT"/
      data lchemvar(240) /"APINCO2"/
      data lchemvar(241) /"APINCOH"/
      data lchemvar(242) /"APINCO"/
c-------------JIALEI--12/2016-----
      data lchemvar(243) /"SOAsm1"/
      data lchemvar(244) /"SOAsm2"/
      data lchemvar(245) /"SOAsm3"/
      data lchemvar(246) /"SOAnOC"/
      data lchemvar(247) /"SOAfOC"/
      data lchemvar(248) /"SOAfBC"/
      data lchemvar(249) /"SOAbOC"/
      data lchemvar(250) /"SOAbBC"/
      data lchemvar(251) /"SOAd1"/
      data lchemvar(252) /"SOAd2"/
      data lchemvar(253) /"SOAd3"/
      data lchemvar(254) /"SOAd4"/
      data lchemvar(255) /"SOAs1"/
      data lchemvar(256) /"SOAs2"/
      data lchemvar(257) /"SOAs3"/
      data lchemvar(258) /"SOAs4"/
c-------------JIALEI--09/2017-----
      data lchemvar(259) /"SOAOm1"/
      data lchemvar(260) /"SOAOm2"/
      data lchemvar(261) /"SOAOm3"/
      data lchemvar(262) /"ORGm1"/
      data lchemvar(263) /"ORGn1"/
      data lchemvar(264) /"ORGm2"/
      data lchemvar(265) /"ORGn2"/
      data lchemvar(266) /"ORGm3"/
      data lchemvar(267) /"ORGn3"/
      data lchemvar(268) /"SO4ORGm1"/
      data lchemvar(269) /"SO4ORGm2"/
      data lchemvar(270) /"SO4ORGm3"/
c------------JIALEI----------------
c-------------gxlin------------------
      data lchemvar(271) /"AD"/
      data lchemvar(272) /"SYNOZ"/
      data lchemvar(273) /"O3S"/
      data lchemvar(274) /"OHS"/
c-------------gxlin----------------

c.... Dynamic (transported) species labels
c
      data ldynvar(1) /"H2O2_su"/    ! Not used
      data ldynvar(2) /"fSO2"/
      data ldynvar(3) /"nSO2"/
      data ldynvar(4) /"nDMS"/
      data ldynvar(5) /"SO4g"/
      data ldynvar(6) /"SO4m1"/
      data ldynvar(7) /"SO4n1"/
      data ldynvar(8) /"SO4m2"/
      data ldynvar(9) /"SO4n2"/
      data ldynvar(10) /"SO4nOC"/
      data ldynvar(11) /"SO4fOC"/
      data ldynvar(12) /"SO4fBC"/
      data ldynvar(13) /"SO4bOC"/
      data ldynvar(14) /"SO4bBC"/
      data ldynvar(15) /"SO4d1"/
      data ldynvar(16) /"SO4d2"/
      data ldynvar(17) /"SO4d3"/
      data ldynvar(18) /"SO4d4"/
      data ldynvar(19) /"SO4s1"/
      data ldynvar(20) /"SO4s2"/
      data ldynvar(21) /"SO4s3"/
      data ldynvar(22) /"SO4s4"/
      data ldynvar(23) /"nOC"/
      data ldynvar(24) /"fOC"/
      data ldynvar(25) /"fBC"/
      data ldynvar(26) /"bOC"/
      data ldynvar(27) /"bBC"/
      data ldynvar(28) /"dust1"/
      data ldynvar(29) /"dust2"/
      data ldynvar(30) /"dust3"/
      data ldynvar(31) /"dust4"/
      data ldynvar(32) /"sslt1"/
      data ldynvar(33) /"sslt2"/
      data ldynvar(34) /"sslt3"/
      data ldynvar(35) /"sslt4"/
      data ldynvar(36) /"O3_su"/    ! Not used
      data ldynvar(37) /"OH_su"/    ! Not used
      data ldynvar(38) /"HO2_su"/    ! Not used
      data ldynvar(39) /"NO3_su"/    ! Not used
      data ldynvar(40) /"ad_su"/    ! Not used
      data ldynvar(41) /"O3"/
      data ldynvar(42) /"NO2"/
      data ldynvar(43) /"NO"/
      data ldynvar(44) /"NO3"/
      data ldynvar(45) /"N2O5"/
      data ldynvar(46) /"HNO3"/
      data ldynvar(47) /"HONO"/
      data ldynvar(48) /"HNO4"/
      data ldynvar(49) /"OH"/
      data ldynvar(50) /"HO2"/
      data ldynvar(51) /"H2O2"/
      data ldynvar(52) /"SO2"/
      data ldynvar(53) /"HSO4"/
      data ldynvar(54) /"H2O"/
      data ldynvar(55) /"CO"/
      data ldynvar(56) /"nmhc"/
      data ldynvar(57) /"CH4"/
      data ldynvar(58) /"C2H6"/
      data ldynvar(59) /"C3H8"/
      data ldynvar(60) /"ALK4"/
      data ldynvar(61) /"ALK7"/
      data ldynvar(62) /"HCHO"/
      data ldynvar(63) /"ALD2"/
      data ldynvar(64) /"RCHO"/
      data ldynvar(65) /"ACET"/
      data ldynvar(66) /"MEK"/
      data ldynvar(67) /"ETHE"/
      data ldynvar(68) /"PRPE"/
      data ldynvar(69) /"BUTE"/
      data ldynvar(70) /"ISOP"/
      data ldynvar(71) /"BENZ"/
      data ldynvar(72) /"TOLU"/
      data ldynvar(73) /"XYLE"/
      data ldynvar(74) /"MCO3"/
      data ldynvar(75) /"PAN"/
      data ldynvar(76) /"nco3"/
      data ldynvar(77) /"PPN"/
      data ldynvar(78) /"MO2"/
      data ldynvar(79) /"ETO2"/
      data ldynvar(80) /"ro2"/
      data ldynvar(81) /"rno2"/
      data ldynvar(82) /"ino3"/
      data ldynvar(83) /"rno3"/
      data ldynvar(84) /"npan"/
      data ldynvar(85) /"MPAN"/
      data ldynvar(86) /"PRPN"/
      data ldynvar(87) /"GLYC"/
      data ldynvar(88) /"IALD"/
      data ldynvar(89) /"HAC"/
      data ldynvar(90) /"GLYX"/
      data ldynvar(91) /"MGLY"/
      data ldynvar(92) /"A-DI"/
      data ldynvar(93) /"PHEN"/
      data ldynvar(94) /"CRES"/
      data ldynvar(95) /"DMP"/
      data ldynvar(96) /"POXY"/
      data ldynvar(97) /"DIAL"/
      data ldynvar(98) /"ADAL"/
      data ldynvar(99) /"MDAL"/
      data ldynvar(100) /"ACHO"/
      data ldynvar(101) /"MVK"/
      data ldynvar(102) /"MACR"/
      data ldynvar(103) /"IPRD"/
      data ldynvar(104) /"HACN"/
      data ldynvar(105) /"rioh"/
      data ldynvar(106) /"crig"/
      data ldynvar(107) /"ACO2"/
      data ldynvar(108) /"ACTA"/
      data ldynvar(109) /"RCOH"/
      data ldynvar(110) /"ROH"/
      data ldynvar(111) /"MOH"/
      data ldynvar(112) /"EOH"/
      data ldynvar(113) /"DMS"/
      data ldynvar(114) /"H2"/
      data ldynvar(115) /"MP"/
      data ldynvar(116) /"rooh"/
      data ldynvar(117) /"APIN"/
      data ldynvar(118) /"LIMO"/
      data ldynvar(119) /"AHO2"/
      data ldynvar(120) /"rmoh"/
c------------------gxlin-----------------
      data ldynvar(121) /"PIP"/
c------------------gxlin----------------
      data ldynvar(122) /"MNO3"/
      data ldynvar(123) /"NITP"/
      data ldynvar(124) /"ISNP"/
      data ldynvar(125) /"INPN"/
      data ldynvar(126) /"PRN2"/
      data ldynvar(127) /"ISNT"/
      data ldynvar(128) /"PINT"/

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** Changed to include secondary organic aerosols
c---------------------gxlin-----------------
      data ldynvar(129) /"AD2P"/
      data ldynvar(130) /"APAN"/
      data ldynvar(131) /"DPAN"/
      data ldynvar(132) /"GPAN"/
      data ldynvar(133) /"XAP"/
      data ldynvar(134) /"ZAP"/
      data ldynvar(135) /"AP"/
      data ldynvar(136) /"XPAN"/
      data ldynvar(137) /"YAP"/
      data ldynvar(138) /"YPAN"/
      data ldynvar(139) /"ZPAN"/
      data ldynvar(140) /"IAP"/
      data ldynvar(141) /"LIP"/
      data ldynvar(142) /"MRP"/
      data ldynvar(143) /"VRP"/
      data ldynvar(144) /"RIO2a"/
      data ldynvar(145) /"RIO2b"/
      data ldynvar(146) /"Z1OH1P"/
      data ldynvar(147) /"RIPOH"/
      data ldynvar(148) /"IEPOX"/
      data ldynvar(149) /"TRIOL"/
      data ldynvar(150) /"IAO2"/
      data ldynvar(151) /"Z1CHO"/
      data ldynvar(152) /"IAO2P1"/
      data ldynvar(153) /"DB1OOH"/
      data ldynvar(154) /"DB2OOH"/
      data ldynvar(155) /"C3O3H6"/
      data ldynvar(156) /"OH_Tg"/
      data ldynvar(157) /"OH_Ag"/
      data ldynvar(158) /"SO5G"/
      data ldynvar(159) /"HSOG"/
      data ldynvar(160) /"CO3"/
      data ldynvar(161) /"H2O2_Tg"/
      data ldynvar(162) /"MGLHY2g"/
      data ldynvar(163) /"PRV"/
      data ldynvar(164) /"MGLOLIg"/
      data ldynvar(165) /"MGSOA1g"/
      data ldynvar(166) /"GLYAC"/
      data ldynvar(167) /"OXLAC"/
      data ldynvar(168) /"GLYOLIg"/
      data ldynvar(169) /"GSOA1g"/
      data ldynvar(170) /"ne_oSOA"/
      data ldynvar(171) /"n_IEPOX"/
      data ldynvar(172) /"ev_A-DI"/
      data ldynvar(173) /"ev_AD2P"/
      data ldynvar(174) /"ev_AP"/
      data ldynvar(175) /"ev_APAN"/
      data ldynvar(176) /"ev_DPAN"/
      data ldynvar(177) /"ev_GPAN"/
      data ldynvar(178) /"ev_NITP"/
      data ldynvar(179) /"ev_XAP"/
      data ldynvar(180) /"ev_XPAN"/
      data ldynvar(181) /"ev_YAP"/
      data ldynvar(182) /"ev_YPAN"/
      data ldynvar(183) /"ev_ZAP"/
      data ldynvar(184) /"ev_ZPAN"/
      data ldynvar(185) /"ev_IAP"/
      data ldynvar(186) /"ev_INPN"/
      data ldynvar(187) /"ev_ISNP"/
      data ldynvar(188) /"ev_LIP"/ 
      data ldynvar(189) /"ev_MRP"/
      data ldynvar(190) /"ev_PINT"/
      data ldynvar(191) /"ev_PIP"/
      data ldynvar(192) /"ev_VRP"/
      data ldynvar(193) /"ev_PRN2"/
      data ldynvar(194) /"ev_RIP"/
      data ldynvar(195) /"ev_DB1H"/
      data ldynvar(196) /"ev_DB2H"/
      data ldynvar(197) /"e_TRIOL"/
      data ldynvar(198) /"SO4G"/
c-------------JIALEI--12/2016-----
      data ldynvar(199) /"SOAsm1"/
      data ldynvar(200) /"SOAsm2"/
      data ldynvar(201) /"SOAsm3"/
      data ldynvar(202) /"SOAnOC"/
      data ldynvar(203) /"SOAfOC"/
      data ldynvar(204) /"SOAfBC"/
      data ldynvar(205) /"SOAbOC"/
      data ldynvar(206) /"SOAbBC"/
      data ldynvar(207) /"SOAd1"/
      data ldynvar(208) /"SOAd2"/
      data ldynvar(209) /"SOAd3"/
      data ldynvar(210) /"SOAd4"/
      data ldynvar(211) /"SOAs1"/
      data ldynvar(212) /"SOAs2"/
      data ldynvar(213) /"SOAs3"/
      data ldynvar(214) /"SOAs4"/
c------------JIALEI----------------
c------------gxlin------------------
      data ldynvar(215) /"AD"/
      data ldynvar(216) /"SYNOZ"/
      data ldynvar(217) /"O3S"/
      data ldynvar(218) /"OHS"/
c-------------gxlin----------------

c
c.... Thermal reaction labels
c

      data (lqkchem(i), i=1,8) /
     & 'DMS + OH = SO2',
     & 'SO2 + OH = H2SO4',
     & 'HO2 + HO2 = H2O2 + O2',
     & 'H2O2 + OH = H2O + HO2',
     & 'SO2(aq) + H2O2(aq) = H2SO4(aq)',
     & 'SO2(aq) + O3(aq) = H2SO4(aq) + O2',
     & 'HO2 + HO2 + H2O = H2O2 + O2 + H2O',
     & 'DMS + NO3 = SO2 +' /

c
c.... Photolytic reaction labels
c

      data (lqjchem(i), i=1,1) /
     & 'H2O2 + hv = 2 OH' /

           end module h_setkin_lchem
