       module h_setkin_par
       implicit none
       public 
c=======================================================================
c
c $Id: setkin_par.h,v 1.5 2003/04/14 22:00:13 jrt Exp $
c
c FILE
c   setkin_par.h
c   12 JUN 02 - PSC
c
c DESCRIPTION
c   This include file sets symbolic constants for the photochemical
c   mechanism.
c
c  Chemistry input file:    2:20 PM 1/14/2003
c  Reaction dictionary:     NMHC reactions.db
c  Setkin files generated:  Tue Feb 11 19:35:44 2003
c  "setkin_par.h" was modified for sulfur chemistry by Xiaohong Liu
c
c========1=========2=========3=========4=========5=========6=========7==


      integer
     &  NSP
     & ,NUM_J
     & ,NUM_K

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** From chemistry version
c      parameter (NSP   =  40)
c      parameter (NUM_J =   1)
c      parameter (NUM_K =   8)

c *** To be changed if the number of SOA forming species changes
c      parameter (NSP   =  176)  ! 40 + 92 + 44

cc----------------------gxlin---------------------------------------
cc       parameter (NSP = 202+21)     
         parameter (NSP = 202+21+16+17+12+6) !JIALEI add 16 SOA uptake on nonSOA
cccccc-----------------------gxlin--------------------------------

      parameter (NUM_J =   56)
c      parameter (NUM_K =   619) ! 8  + 611
c *** To be changed if the number of SOA forming species reactions changes
c      parameter (NUM_K =   685) ! 8+ 611 + 66
c-------------gxlin082209-----------------
      parameter (NUM_K =   1000) ! 8+ 611 + 66+1
c-------------gxlin082209-----------------

c ** End of modifications by Luis Olcese, UM
c ********************************************

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** Changed to include secondary organic aerosols

c *** To be changed if the number of species changes
      integer :: soa_ind_ini, soa_ind_end
c      parameter (soa_ind_ini = 129)
c      parameter (soa_ind_end = 172)

c------------------------gxlin----------------------
    
       parameter (soa_ind_ini = 163+21)
       parameter (soa_ind_end = 197+21)

c-----------------------gxlin----------------------------

c ** End of modifications by Luis Olcese, UM
c ********************************************

c.... Species affiliations and assignments

      integer
     &  NACT
     & ,NCHEM
     & ,NCONST
     & ,NDYN
     & ,NFAM
     & ,NMF
     & ,NSS

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** Changed to include the quadchem/sulfur chemistry
        integer
     &   NUM_H,
     &   NUM_AQ,
     &   NUM_AQQ
c ** End of modifications by Luis Olcese, UM
c ********************************************


c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c      parameter (NACT   =  35)
c      parameter (NCHEM  =  40)
c      parameter (NCONST =   1)
c      parameter (NDYN   =  39)
c      parameter (NFAM   =   1)
c      parameter (NMF    =  39)
c      parameter (NSS    =   0)

c *** To be changed if the number of SOA forming species changes
c      parameter (NACT    =  174) ! 40 + 88 + 44

c----------------gxlin-----------------------------

c       parameter (NACT    =  198+21) ! 174 + 15
       parameter (NACT    =  235+17+12+6) ! 174 + 15  !JIALEI =NSP-4


c *** To be changed if the number of SOA forming species changes
c      parameter (NCHEM   =  173) ! 40 + 89 + 44

      parameter (NCHEM   =  220+16+17+12+6) ! 173 + 15!JIALEI +16
 
c----------------gxlin----------------------------
 
      parameter (NCONST  =    1)

c------------------gxlin---------------------------

c *** To be changed if the number of SOA forming species changes
ccc      parameter (NDYN    =  176) ! 40 + 92 + 44
    
      parameter (NDYN    =  202+21+16+17+12+6) ! 176 +15 !+16JIALEI

c-----------------gxlin-----------------------------
 
      parameter (NFAM    =    1) ! Not used

c *** To be changed if the number of SOA forming species changes
c      parameter (NMF     =  172) ! Not used ?
     
C-------------gxlin-----------------------------
       parameter (NMF    = 198+21+16+17+12+6) !JIALEI +16
C--------------gxlin---------------------------

      parameter (NSS     =    0) ! Not used
      parameter (NUM_H   =    100)
      parameter (NUM_AQ  =    100)
      parameter (NUM_AQQ =    100)

c.... Ancillary input tables

      integer
     &  NSAD

c      parameter (NSAD  =   0)
      parameter (NSAD  =   5)


c      integer IO3
c      parameter (IO3 = 36)

c      integer IOH
c      parameter (IOH = 37)

c      integer IHO2
c      parameter (IHO2 = 38)

c      integer INO3
c      parameter (INO3 = 39)

c      integer IMGAS
c      parameter (IMGAS = 40)



c.... Species individual identifications

      integer IC3H6
      parameter (IC3H6     =  68+21)

c      integer IH2O
c      parameter (IH2O      =  0)

      integer IN2O
      parameter (IN2O      =  0)

c      integer INO
c      parameter (INO       =  0)

c      integer INO2
c      parameter (INO2      =  0)

c      integer IN2O5
c      parameter (IN2O5     =  0)

c      integer IHNO3
c      parameter (IHNO3     =  0)

      integer IHCL
      parameter (IHCL      =  0)

      integer IHOCL
      parameter (IHOCL     =  1)! not used

      integer ICLONO2
      parameter (ICLONO2   =  1)! not used

      integer IHOBR
      parameter (IHOBR     =  1)! not used

      integer IBRONO2
      parameter (IBRONO2   =  1)! not used

c      integer ICH3CCL3
c      parameter (ICH3CCL3  =  0)

c      integer ICCL4
c      parameter (ICCL4     =  0)

c      integer ICFCL3
c      parameter (ICFCL3    =  0)

c      integer ICF2CL2
c      parameter (ICF2CL2   =  0)

c      integer ICH3BR
c      parameter (ICH3BR    =  0)

c      integer IH1301
c      parameter (IH1301    =  0)

c      integer IH1211
c      parameter (IH1211    =  0)

c      integer ICO
c      parameter (ICO       =  0)

c      integer ICH4
c      parameter (ICH4      =  0)

c      integer IC3H6O
c      parameter (IC3H6O    =  0)

c      integer IC5H8
c      parameter (IC5H8     =  0)

c      integer IN2
c      parameter (IN2       =  0)

c      integer INITROGEN
c      parameter (INITROGEN =  0)

c      integer IOXYGEN
c      parameter (IOXYGEN   =  0)

c      integer IO2
c      parameter (IO2       =  0)

c.... Additional model-required parameters

      integer IDEHYD
      parameter (IDEHYD   =   0)

      integer IH2OAIR
      parameter (IH2OAIR  =   0)
c ** End of modifications by Luis Olcese, UM
c ********************************************

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** From chemistry version

c      integer ISYNOZ
c      parameter (ISYNOZ   =   0)


c ** End of modifications by Luis Olcese, UM
c ********************************************

      integer JBRONO21
      parameter (JBRONO21 =   0)

      integer KHNO31
      parameter (KHNO31   =   0)

c.... Species placeholders for sulfchem solver

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** From chemistry version
c      integer IH2O2
c      parameter (IH2O2    =   1)
c ** End of modifications by Luis Olcese, UM
c ********************************************

      integer IFSO2
      parameter (IFSO2    =   2)

      integer INSO2
      parameter (INSO2    =   3)

      integer INDMS
      parameter (INDMS    =   4)

      integer ISO4G
      parameter (ISO4G    =   5)

      integer ISO4M1
      parameter (ISO4M1   =   6)

      integer ISO4N1
      parameter (ISO4N1   =   7)

      integer ISO4M2
      parameter (ISO4M2   =   8)

      integer ISO4N2
      parameter (ISO4N2   =   9)
       
      integer ISO4M3
      parameter (ISO4M3   =  10)

      integer ISO4N3
      parameter (ISO4N3   =  11)

      integer ISO4NOC
      parameter (ISO4NOC  =  12)

      integer ISO4FOC
      parameter (ISO4FOC  =  13)

      integer ISO4FBC
      parameter (ISO4FBC  =  14)

      integer ISO4BOC
      parameter (ISO4BOC  =  15)

      integer ISO4BBC
      parameter (ISO4BBC  =  16)

      ! added by Roy
      integer ISO4OCPHL1
      parameter (ISO4OCPHl1  =  17)

      integer ISO4OCPHL2
      parameter (ISO4OCPHl2  =  18)

      integer ISO4BCPHL1
      parameter (ISO4BCPHl1  =  19)

      integer ISO4BCPHL2
      parameter (ISO4BCPHl2  =  20)

      integer ISO4CPOM
      parameter (ISO4CPOM  =  21)

      integer ISO4CBC
      parameter (ISO4CBC  =  22)

      integer ISO4APOM
      parameter (ISO4APOM  =  23)

      integer ISO4ABC
      parameter (ISO4ABC  =  24)

      integer ISO4D1
      parameter (ISO4D1   =  25)

      integer ISO4D2
      parameter (ISO4D2   =  26)

      integer ISO4D3
      parameter (ISO4D3   =  27)

      integer ISO4D4
      parameter (ISO4D4   =  28)

      integer ISO4S1
      parameter (ISO4S1   =  29)

      integer ISO4S2
      parameter (ISO4S2   =  30)

      integer ISO4S3
      parameter (ISO4S3   =  31)

      integer ISO4S4
      parameter (ISO4S4   =  32)

c----------------gxlin--------10-15-2009------------
      integer INOC
      parameter (INOC     =  33)
      integer IMSA
      parameter (IMSA     =  33)
c----------------gxlin--------10-15-2009-----------------
      integer IFOC
      parameter (IFOC     =  34)

      integer IFBC
      parameter (IFBC     =  35)

      integer IBOC
      parameter (IBOC     =  36)

      integer IBBC
      parameter (IBBC     =  37)
      
      integer IOCPHl1
      parameter (IOCPHl1  =  38)

      integer IOCPHl2
      parameter (IOCPHl2  =  39)

      integer IBCPHl1
      parameter (IBCPHl1  =  40)

      integer IBCPHl2
      parameter (IBCPHl2  =  41)

      integer ICPOM
      parameter (ICPOM     =  42)

      integer ICBC
      parameter (ICBC     =  43)

      integer IAPOM
      parameter (IAPOM     =  44)

      integer IABC
      parameter (IABC     =  45)

      integer IDUST1
      parameter (IDUST1   =  46)

      integer IDUST2
      parameter (IDUST2   =  47)

      integer IDUST3
      parameter (IDUST3   =  48)

      integer IDUST4
      parameter (IDUST4   =  49)

      integer ISSLT1
      parameter (ISSLT1   =  50)

      integer ISSLT2
      parameter (ISSLT2   =  51)

      integer ISSLT3
      parameter (ISSLT3   =  52)

      integer ISSLT4
      parameter (ISSLT4   =  53)
      
      integer IASO2
      parameter (IASO2 = 54)

      integer IASO4
      parameter (IASO4 = 55)

      integer IAH2O
      parameter (IAH2O = 56)

      integer ISO4oSO
      parameter (ISO4oSO   =  57)
     
      integer ISO4GLY
      parameter (ISO4GLY   =  58)

      integer ISO4MGL
      parameter (ISO4MGL   =  59)

      integer ISO4IEP
      parameter (ISO4IEP   =  60)

c ********************************************
c ** Begin of modifications by Luis Olcese, UM
c ** From chemistry version
      integer IO3
      parameter (IO3 = 41+21)     ! Original + 40

      integer IH2O
      parameter (IH2O = 54+21)     ! Original + 40

      integer IH2O2
      parameter (IH2O2 = 51+21)     ! Original + 40

      integer INO
      parameter (INO = 43+21)     ! Original + 40

      integer INO2
      parameter (INO2 = 42+21)     ! Original + 40

      integer INO3
      parameter (INO3 = 44+21)     ! Original + 40

      integer IN2O5
      parameter (IN2O5 = 45+21)     ! Original + 40

      integer IHNO3
      parameter (IHNO3 = 46+21)     ! Original + 40

      integer IOH
      parameter (IOH = 49+21)     ! Original + 40

      integer ICO
      parameter (ICO = 55+21)     ! Original + 40

      integer ICH4
      parameter (ICH4 = 57+21)     ! Original + 40

      integer IC2H4
      parameter (IC2H4 = 67+21)     ! Original + 40

      integer IC5H8
      parameter (IC5H8 = 70+21)     ! Original + 40

      integer IMOH
      parameter (IMOH = 111+21)     ! Original + 40

      integer IAPIN
      parameter (IAPIN = 117+21)     ! Original + 40

      integer ILIMO
      parameter (ILIMO = 118+21)     ! Original + 40
      

      integer IoSO
      parameter (IoSO = 170+21)     ! Original + 40

      integer IevB
      parameter (IevB = 172+21)     ! the beginning of ev_ species
      
      integer IevE
      parameter (IevE = 197+21)     ! the end of ev_ species
 
      integer IGLY
      parameter (IGLY = 169+21)     ! Original + 40

      integer IGLY1
      parameter (IGLY1 = 166+21)     ! Original + 40

      integer IGLY2
      parameter (IGLY2 = 167+21)     ! Original + 40

      integer IMGL
      parameter (IMGL = 165+21)     ! Original + 40

      integer IMGL1
      parameter (IMGL1 = 163+21)     ! Original + 40

      integer IIEP
      parameter (IIEP = 171+21)     ! Original + 40

      integer IMGAS
c *** To be changed if the number of SOA forming species changes
c      parameter (IMGAS = 173)     ! Original + 40 + 44

c-------------------gxlin------------------------------

      parameter (IMGAS = 271)  !JIALEI  

C------------------gxlin------------------------------
 
      integer IO3S
c *** To be changed if the number of SOA forming species changes
c      parameter (IO3S = 175)     ! Original + 40 + 44

c-------------------gxlin-------------------------------

      parameter (IO3S =238+17+12+6)  !JIALEI

c----------------------gxlin------------------------------
C 
      integer IOHS
c *** To be changed if the number of SOA forming species changes
c      parameter (IOHS = 176)     ! Original + 40 + 44

      parameter (IOHS = 239+17+12+6)   ! 176 + 15 !JIALEI

c------------gxlin----------------------------------------

      integer IDMSS
      parameter (IDMSS =134)

      integer ISO2S
      parameter (ISO2S =73)
      
      integer ISO4S
      parameter (ISO4S =74)
      
      integer IHO2
      parameter (IHO2 = 50+21)     ! Original + 40

      integer IC3H6O
      parameter (IC3H6O = 65+21)     ! Original + 40


      integer IO2
      parameter (IO2 = 0)     ! Not used

      integer IN2
      parameter (IN2 = 0)     ! Not used

      integer IOXYGEN
      parameter (IOXYGEN = 0)     ! Not used

      integer INITROGEN
      parameter (INITROGEN = 0)     ! Not used
c ** End of modifications by Luis Olcese, UM
c ********************************************
c-------------------------JIALEI-----------------
      integer ISOASM1
      parameter (ISOASM1   =  237+6)

      integer ISOASM2
      parameter (ISOASM2   =  238+6)

      integer ISOASM3
      parameter (ISOASM3   =  239+6)

      integer ISOAnOC
      parameter (ISOAnOC   =  240+6)

      integer ISOAfOC
      parameter (ISOAfOC   =  241+6)

      integer ISOAfBC
      parameter (ISOAfBC   =  242+6)

      integer ISOAbOC
      parameter (ISOAbOC   =  243+6)

      integer ISOAbBC
      parameter (ISOAbBC   =  244+6)

      integer ISOAd1
      parameter (ISOAd1   =  245+6)

      integer ISOAd2
      parameter (ISOAd2   =  246+6)

      integer ISOAd3
      parameter (ISOAd3   =  247+6)

      integer ISOAd4
      parameter (ISOAd4   =  248+6)

      integer ISOAs1
      parameter (ISOAs1   =  249+6)

      integer ISOAs2
      parameter (ISOAs2   =  250+6)

      integer ISOAs3
      parameter (ISOAs3   =  251+6)

      integer ISOAs4
      parameter (ISOAs4   =  252+6)

c-----JIALEI for nucleation version------
      integer ISOAOM1
      parameter (ISOAOM1   =  253+6)

      integer ISOAOM2
      parameter (ISOAOM2   =  254+6)

      integer ISOAOM3
      parameter (ISOAOM3   =  255+6)


      integer IORGM1
      parameter (IORGM1   =  256+6)

      integer IORGN1
      parameter (IORGN1   =  257+6)

      integer IORGM2
      parameter (IORGM2   =  258+6)

      integer IORGN2
      parameter (IORGN2   =  259+6)

      integer IORGM3
      parameter (IORGM3   =  260+6)

      integer IORGN3
      parameter (IORGN3   =  261+6)

      integer ISO4ORGM1
      parameter (ISO4ORGM1   =  262+6)

      integer ISO4ORGM2
      parameter (ISO4ORGM2   =  263+6)

      integer ISO4ORGM3
      parameter (ISO4ORGM3   =  264+6)

      integer IESTER
      parameter (IESTER   =  235)

      integer IPINIC
      parameter (IPINIC   =  224)

      integer IDIACYLP
      parameter (IDIACYLP   =  225)

      integer IAPINCO
      parameter (IAPINCO   = 242)

      integer IAPINCOH
      parameter (IAPINCOH   = 241)

c-------------------------------------------


c                                  --^--
        end module h_setkin_par


